/* WX^ */
#define A	z80af[0]
#define F	z80af[1]
#define B	z80bc[0]
#define C	z80bc[1]
#define D	z80de[0]
#define E	z80de[1]
#define H	z80hl[0]
#define L	z80hl[1]
#define IXH	z80ix[0]
#define IXL	z80ix[1]
#define IYH	z80iy[0]
#define IYL	z80iy[1]
#define A_D	z80af_d[0]
#define F_D	z80af_d[1]
#define B_D	z80bc_d[0]
#define C_D	z80bc_d[1]
#define D_D	z80de_d[0]
#define E_D	z80de_d[1]
#define H_D	z80hl_d[0]
#define L_D	z80hl_d[1]
#define I	z80i[0]
#define R	0
#define IFF	z80iff
#define INT_MODE	z80im
#define HLT	z80hlt
#define SP	z80sp
#define PC	z80pc

#define GET_R16(r1, r2)	(r1 << 8 | r2)
#define AF	GET_R16(A, F)
#define BC	GET_R16(B, C)
#define DE	GET_R16(D, E)
#define HL	GET_R16(H, L)
#define IX	GET_R16(IXH, IXL)
#define IY	GET_R16(IYH, IYL)
#define AF_D	GET_R16(A_D, F_D)
#define BC_D	GET_R16(B_D, C_D)
#define DE_D	GET_R16(D_D, E_D)
#define HL_D	GET_R16(H_D, L_D)

#define SET_R16(r1, r2, x)	r1 = (x >> 8); r2 = (x & 0xff)
#define SET_AF(x)	SET_R16(A, F, x)
#define SET_BC(x)	SET_R16(B, C, x)
#define SET_DE(x)	SET_R16(D, E, x)
#define SET_HL(x)	SET_R16(H, L, x)
#define SET_IX(x)	SET_R16(IXH, IXL, x)
#define SET_IY(x)	SET_R16(IYH, IYL, x)
#define SET_AF_D(x)	SET_R16(A_D, F_D, x)
#define SET_BC_D(x)	SET_R16(B_D, C_D, x)
#define SET_DE_D(x)	SET_R16(D_D, E_D, x)
#define SET_HL_D(x)	SET_R16(H_D, L_D, x)
#define SET_SP(x)	SP = x

#define INC_R16(r1, r2)	r2++; if(r2 == 0) r1++
#define INC_BC()	INC_R16(B, C)
#define INC_DE()	INC_R16(D, E)
#define INC_HL()	INC_R16(H, L)
#define INC_IX()	INC_R16(IXH, IXL)
#define INC_IY()	INC_R16(IYH, IYL)
#define INC_SP()	SP++

#define DEC_R16(r1, r2)	if(r2-- == 0) r1--
#define DEC_BC()	DEC_R16(B, C)
#define DEC_DE()	DEC_R16(D, E)
#define DEC_HL()	DEC_R16(H, L)
#define DEC_IX()	DEC_R16(IXH, IXL)
#define DEC_IY()	DEC_R16(IYH, IYL)
#define DEC_SP()	SP--

/* tO */
#define MASK_CY	0x01
#define MASK_N	0x02
#define MASK_PV	0x04
#define MASK_HC	0x10
#define MASK_Z	0x40
#define MASK_S	0x80
#define CY	(F & MASK_CY)
#define N	(F & MASK_N)
#define PV	(F & MASK_PV)
#define HC	(F & MASK_HC)
#define Z	(F & MASK_Z)
#define S	(F & MASK_S)
#define CC_NZ	!(F & MASK_Z)
#define CC_Z	(F & MASK_Z)
#define CC_NC	!(F & MASK_CY)
#define CC_C	(F & MASK_CY)
#define CC_PO	!(F & MASK_PV)
#define CC_PE	(F & MASK_PV)
#define CC_P	!(F & MASK_S)
#define CC_M	(F & MASK_S)

/*  */
#define MEM8(x)	z80read8(x)
#define IMM8	z80read8(PC + 1)
#define EQ	(z80read8(PC + 1) & 0x80 ? z80read8(PC + 1) - 0x100: z80read8(PC + 1))
#define STORE8(x, y)	z80write8(x, y)
#define MEM16(x)	z80read16(x)
#define IMM16	z80read16(PC + 1)
#define STORE16(x, y)	z80write16(x, y)

/* L[tOZbg */
#define SET_CY8(acc)	((acc) & 0x100 ? MASK_CY: 0)
#define SET_CY16(acc)	((acc) & 0x10000 ? MASK_CY: 0)
#define SET_CYS(acc)	((acc) < 0 ? MASK_CY: 0)

/* peB/I[o[t[tOZbg */
#define SET_P(acc)	_parity[(acc) & 0xff]
#define SET_V8(acc, a, x)	(((a) ^ (x)) & 0x80   ? 0: (((a) ^ acc) & 0x80 ? MASK_PV: 0))
#define SET_V16(acc, x, y)	(((x) ^ (y)) & 0x8000 ? 0: (((x) ^ acc) & 0x8000 ? MASK_PV: 0))
#define SET_VS8(acc, a, x)	(((a) ^ (x)) & 0x80   ? (((a) ^ acc) & 0x80 ? MASK_PV: 0): 0)
#define SET_VS16(acc, x, y)	(((x) ^ (y)) & 0x8000 ? (((x) ^ acc) & 0x8000 ? MASK_PV: 0): 0)

/* n[tL[Zbg */
#define SET_HC8_CY(a, x, cy)	((((a) & 0x0f) + ((x) & 0x0f) + cy) & 0x10)
#define SET_HC8(a, x)	SET_HC8_CY(a, x, 0)
#define SET_HCS8_CY(a, x, cy)	((((a) & 0x0f) - ((x) & 0x0f) - cy) & 0x10)
#define SET_HCS8(a, x)	SET_HCS8_CY(a, x, 0)
#define SET_HC16_CY(x, y, cy)	((((x) & 0x0fff) + ((y) & 0x0fff) + cy) & 0x1000 ? MASK_HC: 0)
#define SET_HC16(x, y)	SET_HC16_CY(x, y, 0)
#define SET_HCS16_CY(x, y, cy)	((((x) & 0x0fff) - ((y) & 0x0fff) - cy) & 0x1000 ? MASK_HC: 0)
#define SET_HCS16(x, y)	SET_HCS16_CY(x, y, 0)

/* [tOZbg */
#define SET_Z8(acc)	((acc) & 0xff ? 0: MASK_Z)
#define SET_Z16(acc)	((acc) & 0xffff ? 0: MASK_Z)

/* TCtOZbg */
#define SET_S8(acc)	((acc) & 0x80 ? MASK_S: 0)
#define SET_S16(acc)	((acc) & 0x8000 ? MASK_S: 0)

/*  */
#define ADC8(x) \
	_acc = A + (x) + CY; \
	F = SET_CY8(_acc) | SET_V8(_acc, A, x) | SET_HC8_CY(A, x, CY) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define ADC16(x, y) \
	_acc = (x) + (y) + CY; \
	F = SET_CY16(_acc) | SET_V16(_acc, x, y) | SET_HC16_CY(x, y, CY) | SET_Z16(_acc) | SET_S16(_acc); \
	SET_##x(_acc); \
	PC += _length

#define ADD8(x) \
	_acc = A + (x); \
	F = SET_CY8(_acc) | SET_V8(_acc, A, x) | SET_HC8(A, x) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define ADD16(x, y) \
	_acc = (x) + (y); \
	F = SET_CY16(_acc) | Z | PV | S | SET_HC16(x, y); \
	SET_##x(_acc); \
	PC += _length

#define AND(x) \
	_acc = A & (x); \
	F = SET_P(_acc) | MASK_HC | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define BIT(x, y) \
	F = CY | ((y) & (1 << x) ? 0: MASK_PV) | MASK_HC | ((y) & (1 << x) ? 0: MASK_Z) | ((y) & 0x80 & (1 << x)); \
	PC += _length

#define CALL(x, y) \
	if(x) { \
		_state += 7; \
		var extra_states = z80subroutine(y); \
		if(extra_states > 0) { \
			_state += extra_states; \
			PC += _length; \
		} else if(extra_states < 0) { \
			SP -= 2; \
			STORE16(SP, PC + _length); \
			PC = y; \
		} else { \
			_state = z80restStates; \
		} \
	} else \
		PC += _length;

#define INTERRUPT(x) \
	_state = _length = 0; \
	CALL(true, x) \

#define CCF() \
	F = (CY ^ MASK_CY) | PV | (CY ? MASK_HC: 0) | Z | S; \
	PC += _length

#define CP(x) \
	_acc = A - (x); \
	F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, A, x) | SET_HCS8(A, x) | SET_Z8(_acc) | SET_S8(_acc); \
	PC += _length

#define CPD() \
	_acc = A - MEM8(HL); \
	F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, A, MEM8(HL)) | SET_HCS8(A, MEM8(HL)) | SET_Z8(_acc) | SET_S8(_acc); \
	DEC_BC(); \
	DEC_HL(); \
	PC += _length

#define CPDR() \
	do { \
		_acc = A - MEM8(HL); \
		F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, A, MEM8(HL)) | SET_HCS8(A, MEM8(HL)) | SET_Z8(_acc) | SET_S8(_acc); \
		DEC_BC(); \
		DEC_HL(); \
		_state += 21; \
	} while(BC && _acc); \
	_state -= 5; \
	PC += _length

#define CPI() \
	_acc = A - MEM8(HL); \
	F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, A, MEM8(HL)) | SET_HCS8(A, MEM8(HL)) | SET_Z8(_acc) | SET_S8(_acc); \
	DEC_BC(); \
	INC_HL(); \
	PC += _length

#define CPIR() \
	do { \
		_acc = A - MEM8(HL); \
		F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, A, MEM8(HL)) | SET_HCS8(A, MEM8(HL)) | SET_Z8(_acc) | SET_S8(_acc); \
		DEC_BC(); \
		INC_HL(); \
		_state += 21; \
	} while(BC && _acc); \
	_state -= 5; \
	PC += _length

#define CPL() \
	_acc = ~A; \
	F |= MASK_N | MASK_HC; \
	A = _acc; \
	PC += _length

#define DAA() \
	var result = _daa_result(A, F); \
	_acc = A + result.x; \
	F = result.cy | N | SET_P(_acc) | SET_HC8(A, result.x) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define _DEC8(x) \
	_acc = (x) - 1; \
	F = CY | MASK_N | SET_VS8(_acc, x, 1) | SET_HCS8(x, 1) | SET_Z8(_acc) | SET_S8(_acc)
#define DEC8(x) \
	_DEC8(x); \
	x = _acc; \
	PC += _length
#define DEC8_M(x) \
	_DEC8(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length

#define DEC16(x) \
	DEC_##x(); \
	PC += _length

#define DI() \
	IFF = 0; \
	PC += _length

#define DJNZ(x) \
	if(--B) { \
		PC += (x) + _length; \
		_state += 5; \
	} else \
		PC += _length

#define EI() \
	PC += _length; \
	if(IFF != 3) { \
		IFF = 3; \
		if(z80restStates - _state <= 0) \
			z80restStates = 1; \
	}

#define EX_R(x, y) \
	var tmp; \
	tmp = x; SET_##x(y); SET_##y(tmp); \
	PC += _length
#define EX_M(x, y) \
	tmp = MEM16(x); STORE16(x, y); SET_##y(tmp); \
	PC += _length

#define EXX() \
	var tmp; \
	tmp = B; B = B_D; B_D = tmp; \
	tmp = C; C = C_D; C_D = tmp; \
	tmp = D; D = D_D; D_D = tmp; \
	tmp = E; E = E_D; E_D = tmp; \
	tmp = H; H = H_D; H_D = tmp; \
	tmp = L; L = L_D; L_D = tmp; \
	PC += _length

#define HALT() \
	HLT = true; \
	z80restStates = 0; \
	PC += _length

#define IM(x) \
	INT_MODE = x; \
	PC += _length

#define IN_N(x, y) \
	x = z80inport(y); \
	PC += _length
#define IN_C(x, y) \
	x = z80inport(y); \
	F = CY | SET_P(x) | SET_Z8(x) | SET_S8(x); \
	PC += _length

#define IND() \
	STORE8(HL, z80inport(C)); \
	B--; \
	F = CY | (B ? 0: MASK_Z) | PV | S | (MEM8(HL) & 0x80 ? MASK_N: 0) | HC; \
	DEC_HL(); \
	PC += _length; \

#define INDR() \
	while(B) { \
		STORE8(HL, z80inport(C)); \
		B--; \
		DEC_HL(); \
		_state += 21; \
	} \
	_state -= 5; \
	F = CY | MASK_Z | PV | S | MASK_N | HC; \
	PC += _length

#define INI() \
	STORE8(HL, z80inport(C)); \
	B--; \
	INC_HL(); \
	F = CY | (B ? 0: MASK_Z) | PV | S | MASK_N | HC; \
	PC += _length; \

#define INIR() \
	while(B) { \
		STORE8(HL, z80inport(C)); \
		B--; \
		INC_HL(); \
		_state += 21; \
	} \
	_state -= 5; \
	F = CY | MASK_Z | PV | S | MASK_N | HC; \
	PC += _length

#define _INC8(x) \
	_acc = (x) + 1; \
	F = CY | SET_V8(_acc, x, 1) | SET_HC8(x, 1) | SET_Z8(_acc) | SET_S8(_acc)
#define INC8(x) \
	_INC8(x); \
	x = _acc; \
	PC += _length
#define INC8_M(x) \
	_INC8(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length

#define INC16(x) \
	INC_##x(); \
	PC += _length

#define JP(x, y) \
	if(x) { \
		var extra_states; \
		PC = y; \
		if((extra_states = z80subroutine(PC)) >= 0) { \
			PC = MEM16(SP); \
			SP += 2; \
			_state += extra_states; \
		} \
	} else \
		PC += _length

#define JR(x, y) \
	if(x) { \
		PC += (y) + _length; \
		_state += 5; \
	} else \
		PC += _length

#define LD(x, y) \
	x = y; \
	PC += _length
#define LD_A_I() \
	_acc = I; \
	F = CY | (IFF & 0x02 ? 0: MASK_PV) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length
#define LD_A_R() \
	_acc = R; \
	F = CY | (IFF & 0x02 ? 0: MASK_PV) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length
#define LD16(x, y) \
	SET_##x(y); \
	PC += _length
#define ST8(x, y) \
	STORE8(x, y); \
	PC += _length
#define ST16(x, y) \
	STORE16(x, y); \
	PC += _length

#define LDD() \
	STORE8(DE, MEM8(HL)); \
	DEC_DE(); \
	DEC_HL(); \
	DEC_BC(); \
	F = CY | (BC ? MASK_PV: 0) | Z | S; \
	PC += _length

#define LDDR() \
	do { \
		STORE8(DE, MEM8(HL)); \
		DEC_DE(); \
		DEC_HL(); \
		DEC_BC(); \
		_state += 21; \
	} while(BC); \
	_state -= 5; \
	F = CY | Z | S; \
	PC += _length

#define LDI() \
	STORE8(DE, MEM8(HL)); \
	DEC_BC(); \
	F = CY | (BC ? MASK_PV: 0) | Z | S; \
	INC_DE(); \
	INC_HL(); \
	PC += _length

#define LDIR() \
	do { \
		STORE8(DE, MEM8(HL)); \
		INC_DE(); \
		INC_HL(); \
		DEC_BC(); \
		_state += 21; \
	} while(BC); \
	_state -= 5; \
	F = CY | Z | S; \
	PC += _length

#define NEG() \
	_acc = -A; \
	F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, 0, A) | SET_HCS8(0, A) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define NOP() \
	PC += _length

#define OR(x) \
	_acc = A | (x); \
	F = SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define OUT(x, y) \
	z80outport(x, y); \
	PC += _length

#define OUTD() \
	z80outport(C, MEM8(HL)); \
	B--; \
	DEC_HL(); \
	F = CY | MASK_N | PV | HC | (B ? 0: MASK_Z) | S; \
	PC += _length

#define OTDR() \
	while(B) { \
		z80outport(C, MEM8(HL)); \
		B--; \
		DEC_HL(); \
		_state += 21; \
	} \
	_state -= 5; \
	F = CY | MASK_N | PV | HC | MASK_Z | S; \
	PC += _length

#define OUTI() \
	z80outport(C, MEM8(HL)); \
	B--; \
	INC_HL(); \
	F = CY | MASK_N | PV | HC | (B ? 0: MASK_Z) | S; \
	PC += _length

#define OTIR() \
	while(B) { \
		z80outport(C, MEM8(HL)); \
		B--; \
		INC_HL(); \
		_state += 21; \
	} \
	_state -= 5; \
	F = CY | MASK_N | PV | HC | MASK_Z | S; \
	PC += _length

#define POP(x) \
	SET_##x(MEM16(SP)); \
	SP += 2; \
	PC += _length

#define PUSH(x) \
	SP -= 2; \
	STORE16(SP, x); \
	PC += _length

#define RES(x, y) \
	y &= ~(1 << x); \
	PC += _length
#define RES_M(x, y) \
	STORE8(y, MEM8(y) & ~(1 << x)); \
	PC += _length
#define RES_M_R(x, y, z) \
	z = MEM8(y) & ~(1 << x); \
	STORE8(y, z); \
	PC += _length

#define RET(x) \
	if(x) { \
		PC = MEM16(SP); \
		SP += 2; \
		_state += 6; \
	} else \
		PC += _length

#define RETI() \
	RET(true)

#define RETN() \
	IFF = (IFF << 1) & 0x03; \
	RET(true)

#define _RL(x) \
	_acc = ((x) << 1) | CY; \
	F = ((x) & 0x80 ? MASK_CY: 0) | SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc)
#define RL(x) \
	_RL(x); \
	x = _acc; \
	PC += _length
#define RL_M(x) \
	_RL(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define RL_M_R(x, y) \
	_RL(MEM8(x)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define RLA() \
	_acc = (A << 1) | CY; \
	F = (A & 0x80 ? MASK_CY: 0) | PV | Z | S; \
	A = _acc; \
	PC += _length

#define _RLC(x) \
	_acc = ((x) << 1) | ((x) & 0x80 ? 0x01: 0); \
	F = ((x) & 0x80 ? MASK_CY: 0) | SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc)
#define RLC(x) \
	_RLC(x); \
	x = _acc; \
	PC += _length
#define RLC_M(x) \
	_RLC(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define RLC_M_R(x, y) \
	_RLC(MEM8(x)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define RLCA() \
	_acc = (A << 1) | (A & 0x80 ? 0x01: 0); \
	F = (A & 0x80 ? MASK_CY: 0) | PV | Z | S; \
	A = _acc; \
	PC += _length

#define RLD() \
	_acc = (A & 0xf0) | (MEM8(HL) >> 4); \
	STORE8(HL, (MEM8(HL) << 4) | (A & 0x0f)); \
	F = CY | SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define _RR(x) \
	_acc = ((x) >> 1) | (CY ? 0x80: 0); \
	F = ((x) & 0x01) | SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc)
#define RR(x) \
	_RR(x); \
	x = _acc; \
	PC += _length
#define RR_M(x) \
	_RR(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define RR_M_R(x, y) \
	_RR(MEM8(y)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define RRA() \
	_acc = (A >> 1) | (CY ? 0x80: 0); \
	F = (A & 0x01) | PV | Z | S; \
	A = _acc; \
	PC += _length

#define _RRC(x) \
	_acc = ((x) >> 1) | ((x) & 0x01 ? 0x80: 0); \
	F = ((x) & 0x01) | SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc)
#define RRC(x) \
	_RRC(x); \
	x = _acc; \
	PC += _length
#define RRC_M(x) \
	_RRC(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define RRC_M_R(x, y) \
	_RRC(MEM8(x)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define RRCA() \
	_acc = (A >> 1) | (A & 0x01 ? 0x80: 0); \
	F = (A & 0x01) | PV | Z | S; \
	A = _acc; \
	PC += _length

#define RRD() \
	_acc = (A & 0xf0) | (MEM8(HL) & 0x0f); \
	STORE8(HL, (MEM8(HL) >> 4) | (A << 4)); \
	F = CY | SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define RST(x) \
	CALL(true, x)

#define SBC8(x) \
	_acc = A - (x) - CY; \
	F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, A, x) | SET_HCS8_CY(A, x, CY) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define SBC16(x, y) \
	_acc = (x) - (y) - CY; \
	F = SET_CYS(_acc) | MASK_N | SET_VS16(_acc, x, y) | SET_HCS16_CY(x, y, CY) | SET_Z16(_acc) | SET_S16(_acc); \
	SET_##x(_acc); \
	PC += _length

#define SCF() \
	F |= MASK_CY; \
	PC += _length

#define SET(x, y) \
	y |= (1 << x); \
	PC += _length
#define SET_M(x, y) \
	STORE8(y, MEM8(y) | (1 << x)); \
	PC += _length
#define SET_M_R(x, y, z) \
	z = MEM8(y) | (1 << x); \
	STORE8(y, z); \
	PC += _length

#define _SLA(x) \
	_acc = (x) << 1; \
	F = ((x) & 0x80 ? MASK_CY: 0) | SET_P(_acc) | SET_S8(_acc) | SET_Z8(_acc)
#define SLA(x) \
	_SLA(x); \
	x = _acc; \
	PC += _length
#define SLA_M(x) \
	_SLA(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define SLA_M_R(x, y) \
	_SLA(MEM8(x)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define _SLL(x) \
	_acc = (x) << 1 | 1; \
	F = ((x) & 0x80 ? MASK_CY: 0) | SET_P(_acc) | SET_S8(_acc) | SET_Z8(_acc)
#define SLL(x) \
	_SLL(x); \
	x = _acc; \
	PC += _length
#define SLL_M(x) \
	_SLL(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define SLL_M_R(x, y) \
	_SLL(MEM8(x)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define _SRA(x) \
	_acc = ((x) >> 1) | ((x) & 0x80); \
	F = ((x) & 0x01 ? MASK_CY: 0) | SET_P(_acc) | SET_S8(_acc) | SET_Z8(_acc)
#define SRA(x) \
	_SRA(x); \
	x = _acc; \
	PC += _length
#define SRA_M(x) \
	_SRA(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define SRA_M_R(x, y) \
	_SRA(MEM8(x)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define _SRL(x) \
	_acc = (x) >> 1; \
	F = ((x) & 0x01 ? MASK_CY: 0) | SET_P(_acc) | SET_S8(_acc) | SET_Z8(_acc)
#define SRL(x) \
	_SRL(x); \
	x = _acc; \
	PC += _length
#define SRL_M(x) \
	_SRL(MEM8(x)); \
	STORE8(x, _acc); \
	PC += _length
#define SRL_M_R(x, y) \
	_SRL(MEM8(x)); \
	y = _acc; \
	STORE8(x, y); \
	PC += _length

#define SUB8(x) \
	_acc = A - (x); \
	F = SET_CYS(_acc) | MASK_N | SET_VS8(_acc, A, x) | SET_HCS8(A, x) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

#define XOR(x) \
	_acc = A ^ (x); \
	F = SET_P(_acc) | SET_Z8(_acc) | SET_S8(_acc); \
	A = _acc; \
	PC += _length

/* Xe[g */
var _stateXX = new Array(
	4, 10,  7,  6,  4,  4,  7,  4,  4, 11,  7,  6,  4,  4,  7,  4,
	8, 10,  7,  6,  4,  4,  7,  4,  7, 11,  7,  6,  4,  4,  7,  4,
	7, 10, 16,  6,  4,  4,  7,  4,  7, 11, 16,  6,  4,  4,  7,  4,
	7, 10, 13,  6, 11, 11, 10,  4,  7, 11, 13,  6,  4,  4,  7,  4,
	4,  4,  4,  4,  4,  4,  7,  4,  4,  4,  4,  4,  4,  4,  7,  4,
	4,  4,  4,  4,  4,  4,  7,  4,  4,  4,  4,  4,  4,  4,  7,  4,
	4,  4,  4,  4,  4,  4,  7,  4,  4,  4,  4,  4,  4,  4,  7,  4,
	7,  7,  7,  7,  7,  7,  4,  7,  4,  4,  4,  4,  4,  4,  7,  4,
	4,  4,  4,  4,  4,  4,  7,  4,  4,  4,  4,  4,  4,  4,  7,  4,
	4,  4,  4,  4,  4,  4,  7,  4,  4,  4,  4,  4,  4,  4,  7,  4,
	4,  4,  4,  4,  4,  4,  7,  4,  4,  4,  4,  4,  4,  4,  7,  4,
	4,  4,  4,  4,  4,  4,  7,  4,  4,  4,  4,  4,  4,  4,  7,  4,
	5, 10, 10, 10, 10, 11,  7, 11,  5,  4, 10,  0, 10, 10,  7, 11,
	5, 10, 10, 11, 10, 11,  7, 11,  5,  4, 10, 11, 10,  0,  7, 11,
	5, 10, 10, 19, 10, 11,  7, 11,  5,  4, 10,  4, 10,  0,  7, 11,
	5, 10, 10,  4, 10, 11,  7, 11,  5,  6, 10,  4, 10,  0,  7, 11
);
var _stateCBXX = new Array(
	8, 8, 8, 8, 8, 8, 15, 8, 8, 8, 8, 8, 8, 8, 15, 8,
	8, 8, 8, 8, 8, 8, 15, 8, 8, 8, 8, 8, 8, 8, 15, 8,
	8, 8, 8, 8, 8, 8, 15, 8, 8, 8, 8, 8, 8, 8, 15, 8,
	8, 8, 8, 8, 8, 8, 15, 8, 8, 8, 8, 8, 8, 8, 15, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8,
	8, 8, 8, 8, 8, 8, 12, 8, 8, 8, 8, 8, 8, 8, 12, 8
);
var _stateDDXX = new Array(
	 8,  8,  8,  8,  8,  8,  8,  8,  8, 10,  8,  8, 8, 8,  8, 8,
	 8,  8,  8,  8,  8,  8,  8,  8,  8, 10,  8,  8, 8, 8,  8, 8,
	 8, 14, 20, 10,  8,  8, 12,  8,  8, 10, 20, 10, 8, 8, 12, 8,
	 8,  8,  8,  8, 19, 19, 19,  8,  8, 10,  8,  8, 8, 8,  8, 8,
	 8,  8,  8,  8,  8,  8, 19,  8,  8,  8,  8,  8, 8, 8, 19, 8,
	 8,  8,  8,  8,  8,  8, 19,  8,  8,  8,  8,  8, 8, 8, 19, 8,
	 8,  8,  8,  8,  8,  8, 19,  8,  8,  8,  8,  8, 8, 8, 19, 8,
	19, 19, 19, 19, 19, 19,  8, 19,  8,  8,  8,  8, 8, 8, 19, 8,
	 8,  8,  8,  8,  8,  8, 19,  8,  8,  8,  8,  8, 8, 8, 19, 8,
	 8,  8,  8,  8,  8,  8, 19,  8,  8,  8,  8,  8, 8, 8, 19, 8,
	 8,  8,  8,  8,  8,  8, 19,  8,  8,  8,  8,  8, 8, 8, 19, 8,
	 8,  8,  8,  8,  8,  8, 19,  8,  8,  8,  8,  8, 8, 8, 19, 8,
	 8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  0, 8, 8,  8, 8,
	 8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8, 8, 8,  8, 8,
	 8, 14,  8, 23,  8, 15,  8,  8,  8,  8,  8,  8, 8, 8,  8, 8,
	 8,  8,  8,  8,  8,  8,  8,  8,  8, 10,  8,  8, 8, 8,  8, 8
);
var _stateDDCBXX = new Array(
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 20, 12, 12, 12, 12, 12, 12, 12, 20, 12,
	12, 12, 12, 12, 12, 12, 20, 12, 12, 12, 12, 12, 12, 12, 20, 12,
	12, 12, 12, 12, 12, 12, 20, 12, 12, 12, 12, 12, 12, 12, 20, 12,
	12, 12, 12, 12, 12, 12, 20, 12, 12, 12, 12, 12, 12, 12, 20, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12,
	12, 12, 12, 12, 12, 12, 23, 12, 12, 12, 12, 12, 12, 12, 23, 12
);
var _stateEDXX = new Array(
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	12, 12, 15, 20, 8, 14, 8,  9, 12, 12, 15, 20, 8, 14, 8,  9,
	12, 12, 15, 20, 8,  8, 8,  9, 12, 12, 15, 20, 8,  8, 8,  9,
	12, 12, 15 ,16, 8,  8, 8, 18, 12, 12, 15, 20, 8,  8, 8, 18,
	 8,  8, 15, 20, 8,  8, 8,  8, 11, 12, 15, 20, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	16, 16, 16, 16, 8,  8, 8,  8, 16, 16, 16, 16, 8,  8, 8,  8,
	 0,  0,  0,  0, 8,  8, 8,  8,  0,  0,  0,  0, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8,
	 8,  8,  8,  8, 8,  8, 8,  8,  8,  8,  8,  8, 8,  8, 8,  8
);

/* ߒ */
var _lengthXX = new Array(
	1, 3, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	2, 3, 1, 1, 1, 1, 2, 1, 2, 1, 1, 1, 1, 1, 2, 1,
	2, 3, 3, 1, 1, 1, 2, 1, 2, 1, 3, 1, 1, 1, 2, 1,
	2, 3, 3, 1, 1, 1, 2, 1, 2, 1, 3, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 3, 3, 3, 1, 2, 1, 1, 1, 3, 0, 3, 3, 2, 1,
	1, 1, 3, 2, 3, 1, 2, 1, 1, 1, 3, 2, 3, 0, 2, 1,
	1, 1, 3, 1, 3, 1, 2, 1, 1, 1, 3, 1, 3, 0, 2, 1,
	1, 1, 3, 1, 3, 1, 2, 1, 1, 1, 3, 1, 3, 0, 2, 1
);
var _lengthCBXX = new Array(
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
);
var _lengthDDXX = new Array(
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 3, 3, 1, 1, 1, 2, 1, 1, 1, 3, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 2, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	2, 2, 2, 2, 2, 2, 1, 2, 1, 1, 1, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 2, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
);
var _lengthDDCBXX = new Array(
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3
);
var _lengthEDXX = new Array(
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1,
	1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1,
	1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1,
	1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
);
var _parity = new Uint8Array(
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV,
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV,
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0,
	MASK_PV, 0, 0, MASK_PV, 0, MASK_PV, MASK_PV, 0, 0, MASK_PV, MASK_PV, 0, MASK_PV, 0, 0, MASK_PV
);
var _acc;
var _x;
var _y;
var _length;
var _states;
var z80af = new Uint8Array(2);
var z80bc = new Uint8Array(2);
var z80de = new Uint8Array(2);
var z80hl = new Uint8Array(2);
var z80ix = new Uint8Array(2);
var z80iy = new Uint8Array(2);
var z80af_d = new Uint8Array(2);
var z80bc_d = new Uint8Array(2);
var z80de_d = new Uint8Array(2);
var z80hl_d = new Uint8Array(2);
var z80i = new Uint8Array(1);
var z80sp = 0;
var z80pc = 0;
var z80iff = 0;
var z80im = 0;
var z80hlt = 0;
var z80executeStates = 0;
var z80restStates = 0;

function _daa_result(a, f) {
	switch(f & (MASK_CY | MASK_N | MASK_HC)) {
	case 0:
		if(a < 0x9a) {
			if((a & 0x0f) < 0x0a)
				return { x: 0x00, cy: 0 };
			else
				return { x: 0x06, cy: 0 };
		} else {
			if((a & 0x0f) < 0x0a)
				return { x: 0x60, cy: 1 };
			else
				return { x: 0x66, cy: 1 };
		}
	case MASK_CY:
		if((a & 0x0f) < 0x0a)
			return { x: 0x60, cy: 1 };
		else
			return { x: 0x66, cy: 1 };
	case MASK_N:
		if(a < 0x9a) {
			if((a & 0x0f) < 0x0a)
				return { x: 0x00, cy: 0 };
			else
				return { x: 0xfa, cy: 0 };
		} else {
			if((a & 0x0f) < 0x0a)
				return { x: 0xa0, cy: 1 };
			else
				return { x: 0x9a, cy: 1 };
		}
	case MASK_CY | MASK_N:
		if((a & 0x0f) < 0x0a)
			return { x: 0xa0, cy: 1 };
		else
			return { x: 0x9a, cy: 1 };
	case MASK_HC:
		if(a < 0x9a)
			return { x: 0x06, cy: 0 };
		else
			return { x: 0x66, cy: 1 };
	case MASK_CY | MASK_HC:
		return { x: 0x66, cy: 1 };
	case MASK_N | MASK_HC:
		if(a < 0x9a)
			return { x: 0xfa, cy: 0 };
		else
			return { x: 0x9a, cy: 1 };
	case MASK_CY | MASK_N | MASK_HC:
		return { x: 0x9a, cy: 1 };
	default:
		return { x: 0, cy: 0 };
	}
}

_z80executeCBXX = new Array(
	function() { RLC(B); },	/* 0x00 */
	function() { RLC(C); },	/* 0x01 */
	function() { RLC(D); },	/* 0x02 */
	function() { RLC(E); },	/* 0x03 */
	function() { RLC(H); },	/* 0x04 */
	function() { RLC(L); },	/* 0x05 */
	function() { RLC_M(HL); },	/* 0x06 */
	function() { RLC(A); },	/* 0x07 */

	function() { RRC(B); },	/* 0x08 */
	function() { RRC(C); },	/* 0x09 */
	function() { RRC(D); },	/* 0x0a */
	function() { RRC(E); },	/* 0x0b */
	function() { RRC(H); },	/* 0x0c */
	function() { RRC(L); },	/* 0x0d */
	function() { RRC_M(HL); },	/* 0x0e */
	function() { RRC(A); },	/* 0x0f */

	function() { RL(B); },	/* 0x10 */
	function() { RL(C); },	/* 0x11 */
	function() { RL(D); },	/* 0x12 */
	function() { RL(E); },	/* 0x13 */
	function() { RL(H); },	/* 0x14 */
	function() { RL(L); },	/* 0x15 */
	function() { RL_M(HL); },	/* 0x16 */
	function() { RL(A); },	/* 0x17 */

	function() { RR(B); },	/* 0x18 */
	function() { RR(C); },	/* 0x19 */
	function() { RR(D); },	/* 0x1a */
	function() { RR(E); },	/* 0x1b */
	function() { RR(H); },	/* 0x1c */
	function() { RR(L); },	/* 0x1d */
	function() { RR_M(HL); },	/* 0x1e */
	function() { RR(A); },	/* 0x1f */

	function() { SLA(B); },	/* 0x20 */
	function() { SLA(C); },	/* 0x21 */
	function() { SLA(D); },	/* 0x22 */
	function() { SLA(E); },	/* 0x23 */
	function() { SLA(H); },	/* 0x24 */
	function() { SLA(L); },	/* 0x25 */
	function() { SLA_M(HL); },	/* 0x26 */
	function() { SLA(A); },	/* 0x27 */

	function() { SRA(B); },	/* 0x28 */
	function() { SRA(C); },	/* 0x29 */
	function() { SRA(D); },	/* 0x2a */
	function() { SRA(E); },	/* 0x2b */
	function() { SRA(H); },	/* 0x2c */
	function() { SRA(L); },	/* 0x2d */
	function() { SRA_M(HL); },	/* 0x2e */
	function() { SRA(A); },	/* 0x2f */

	function() { SLL(B); },	/* 0x30 */
	function() { SLL(C); },	/* 0x31 */
	function() { SLL(D); },	/* 0x32 */
	function() { SLL(E); },	/* 0x33 */
	function() { SLL(H); },	/* 0x34 */
	function() { SLL(L); },	/* 0x35 */
	function() { SLL_M(HL); },	/* 0x36 */
	function() { SLL(A); },	/* 0x37 */

	function() { SRL(B); },	/* 0x38 */
	function() { SRL(C); },	/* 0x39 */
	function() { SRL(D); },	/* 0x3a */
	function() { SRL(E); },	/* 0x3b */
	function() { SRL(H); },	/* 0x3c */
	function() { SRL(L); },	/* 0x3d */
	function() { SRL_M(HL); },	/* 0x3e */
	function() { SRL(A); },	/* 0x3f */

	function() { BIT(0, B); },	/* 0x40 */
	function() { BIT(0, C); },	/* 0x41 */
	function() { BIT(0, D); },	/* 0x42 */
	function() { BIT(0, E); },	/* 0x43 */
	function() { BIT(0, H); },	/* 0x44 */
	function() { BIT(0, L); },	/* 0x45 */
	function() { BIT(0, MEM8(HL)); },	/* 0x46 */
	function() { BIT(0, A); },	/* 0x47 */

	function() { BIT(1, B); },	/* 0x48 */
	function() { BIT(1, C); },	/* 0x49 */
	function() { BIT(1, D); },	/* 0x4a */
	function() { BIT(1, E); },	/* 0x4b */
	function() { BIT(1, H); },	/* 0x4c */
	function() { BIT(1, L); },	/* 0x4d */
	function() { BIT(1, MEM8(HL)); },	/* 0x4e */
	function() { BIT(1, A); },	/* 0x4f */

	function() { BIT(2, B); },	/* 0x50 */
	function() { BIT(2, C); },	/* 0x51 */
	function() { BIT(2, D); },	/* 0x52 */
	function() { BIT(2, E); },	/* 0x53 */
	function() { BIT(2, H); },	/* 0x54 */
	function() { BIT(2, L); },	/* 0x55 */
	function() { BIT(2, MEM8(HL)); },	/* 0x56 */
	function() { BIT(2, A); },	/* 0x57 */

	function() { BIT(3, B); },	/* 0x58 */
	function() { BIT(3, C); },	/* 0x59 */
	function() { BIT(3, D); },	/* 0x5a */
	function() { BIT(3, E); },	/* 0x5b */
	function() { BIT(3, H); },	/* 0x5c */
	function() { BIT(3, L); },	/* 0x5d */
	function() { BIT(3, MEM8(HL)); },	/* 0x5e */
	function() { BIT(3, A); },	/* 0x5f */

	function() { BIT(4, B); },	/* 0x60 */
	function() { BIT(4, C); },	/* 0x61 */
	function() { BIT(4, D); },	/* 0x62 */
	function() { BIT(4, E); },	/* 0x63 */
	function() { BIT(4, H); },	/* 0x64 */
	function() { BIT(4, L); },	/* 0x65 */
	function() { BIT(4, MEM8(HL)); },	/* 0x66 */
	function() { BIT(4, A); },	/* 0x67 */

	function() { BIT(5, B); },	/* 0x68 */
	function() { BIT(5, C); },	/* 0x69 */
	function() { BIT(5, D); },	/* 0x6a */
	function() { BIT(5, E); },	/* 0x6b */
	function() { BIT(5, H); },	/* 0x6c */
	function() { BIT(5, L); },	/* 0x6d */
	function() { BIT(5, MEM8(HL)); },	/* 0x6e */
	function() { BIT(5, A); },	/* 0x6f */

	function() { BIT(6, B); },	/* 0x70 */
	function() { BIT(6, C); },	/* 0x71 */
	function() { BIT(6, D); },	/* 0x72 */
	function() { BIT(6, E); },	/* 0x73 */
	function() { BIT(6, H); },	/* 0x74 */
	function() { BIT(6, L); },	/* 0x75 */
	function() { BIT(6, MEM8(HL)); },	/* 0x76 */
	function() { BIT(6, A); },	/* 0x77 */

	function() { BIT(7, B); },	/* 0x78 */
	function() { BIT(7, C); },	/* 0x79 */
	function() { BIT(7, D); },	/* 0x7a */
	function() { BIT(7, E); },	/* 0x7b */
	function() { BIT(7, H); },	/* 0x7c */
	function() { BIT(7, L); },	/* 0x7d */
	function() { BIT(7, MEM8(HL)); },	/* 0x7e */
	function() { BIT(7, A); },	/* 0x7f */

	function() { RES(0, B); },	/* 0x80 */
	function() { RES(0, C); },	/* 0x81 */
	function() { RES(0, D); },	/* 0x82 */
	function() { RES(0, E); },	/* 0x83 */
	function() { RES(0, H); },	/* 0x84 */
	function() { RES(0, L); },	/* 0x85 */
	function() { RES_M(0, HL); },	/* 0x86 */
	function() { RES(0, A); },	/* 0x87 */

	function() { RES(1, B); },	/* 0x88 */
	function() { RES(1, C); },	/* 0x89 */
	function() { RES(1, D); },	/* 0x8a */
	function() { RES(1, E); },	/* 0x8b */
	function() { RES(1, H); },	/* 0x8c */
	function() { RES(1, L); },	/* 0x8d */
	function() { RES_M(1, HL); },	/* 0x8e */
	function() { RES(1, A); },	/* 0x8f */

	function() { RES(2, B); },	/* 0x90 */
	function() { RES(2, C); },	/* 0x91 */
	function() { RES(2, D); },	/* 0x92 */
	function() { RES(2, E); },	/* 0x93 */
	function() { RES(2, H); },	/* 0x94 */
	function() { RES(2, L); },	/* 0x95 */
	function() { RES_M(2, HL); },	/* 0x96 */
	function() { RES(2, A); },	/* 0x97 */

	function() { RES(3, B); },	/* 0x98 */
	function() { RES(3, C); },	/* 0x99 */
	function() { RES(3, D); },	/* 0x9a */
	function() { RES(3, E); },	/* 0x9b */
	function() { RES(3, H); },	/* 0x9c */
	function() { RES(3, L); },	/* 0x9d */
	function() { RES_M(3, HL); },	/* 0x9e */
	function() { RES(3, A); },	/* 0x9f */

	function() { RES(4, B); },	/* 0xa0 */
	function() { RES(4, C); },	/* 0xa1 */
	function() { RES(4, D); },	/* 0xa2 */
	function() { RES(4, E); },	/* 0xa3 */
	function() { RES(4, H); },	/* 0xa4 */
	function() { RES(4, L); },	/* 0xa5 */
	function() { RES_M(4, HL); },	/* 0xa6 */
	function() { RES(4, A); },	/* 0xa7 */

	function() { RES(5, B); },	/* 0xa8 */
	function() { RES(5, C); },	/* 0xa9 */
	function() { RES(5, D); },	/* 0xaa */
	function() { RES(5, E); },	/* 0xab */
	function() { RES(5, H); },	/* 0xac */
	function() { RES(5, L); },	/* 0xad */
	function() { RES_M(5, HL); },	/* 0xae */
	function() { RES(5, A); },	/* 0xaf */

	function() { RES(6, B); },	/* 0xb0 */
	function() { RES(6, C); },	/* 0xb1 */
	function() { RES(6, D); },	/* 0xb2 */
	function() { RES(6, E); },	/* 0xb3 */
	function() { RES(6, H); },	/* 0xb4 */
	function() { RES(6, L); },	/* 0xb5 */
	function() { RES_M(6, HL); },	/* 0xb6 */
	function() { RES(6, A); },	/* 0xb7 */

	function() { RES(7, B); },	/* 0xb8 */
	function() { RES(7, C); },	/* 0xb9 */
	function() { RES(7, D); },	/* 0xba */
	function() { RES(7, E); },	/* 0xbb */
	function() { RES(7, H); },	/* 0xbc */
	function() { RES(7, L); },	/* 0xbd */
	function() { RES_M(7, HL); },	/* 0xbe */
	function() { RES(7, A); },	/* 0xbf */

	function() { SET(0, B); },	/* 0xc0 */
	function() { SET(0, C); },	/* 0xc1 */
	function() { SET(0, D); },	/* 0xc2 */
	function() { SET(0, E); },	/* 0xc3 */
	function() { SET(0, H); },	/* 0xc4 */
	function() { SET(0, L); },	/* 0xc5 */
	function() { SET_M(0, HL); },	/* 0xc6 */
	function() { SET(0, A); },	/* 0xc7 */

	function() { SET(1, B); },	/* 0xc8 */
	function() { SET(1, C); },	/* 0xc9 */
	function() { SET(1, D); },	/* 0xca */
	function() { SET(1, E); },	/* 0xcb */
	function() { SET(1, H); },	/* 0xcc */
	function() { SET(1, L); },	/* 0xcd */
	function() { SET_M(1, HL); },	/* 0xce */
	function() { SET(1, A); },	/* 0xcf */

	function() { SET(2, B); },	/* 0xd0 */
	function() { SET(2, C); },	/* 0xd1 */
	function() { SET(2, D); },	/* 0xd2 */
	function() { SET(2, E); },	/* 0xd3 */
	function() { SET(2, H); },	/* 0xd4 */
	function() { SET(2, L); },	/* 0xd5 */
	function() { SET_M(2, HL); },	/* 0xd6 */
	function() { SET(2, A); },	/* 0xd7 */

	function() { SET(3, B); },	/* 0xd8 */
	function() { SET(3, C); },	/* 0xd9 */
	function() { SET(3, D); },	/* 0xda */
	function() { SET(3, E); },	/* 0xdb */
	function() { SET(3, H); },	/* 0xdc */
	function() { SET(3, L); },	/* 0xdd */
	function() { SET_M(3, HL); },	/* 0xde */
	function() { SET(3, A); },	/* 0xdf */

	function() { SET(4, B); },	/* 0xe0 */
	function() { SET(4, C); },	/* 0xe1 */
	function() { SET(4, D); },	/* 0xe2 */
	function() { SET(4, E); },	/* 0xe3 */
	function() { SET(4, H); },	/* 0xe4 */
	function() { SET(4, L); },	/* 0xe5 */
	function() { SET_M(4, HL); },	/* 0xe6 */
	function() { SET(4, A); },	/* 0xe7 */

	function() { SET(5, B); },	/* 0xe8 */
	function() { SET(5, C); },	/* 0xe9 */
	function() { SET(5, D); },	/* 0xea */
	function() { SET(5, E); },	/* 0xeb */
	function() { SET(5, H); },	/* 0xec */
	function() { SET(5, L); },	/* 0xed */
	function() { SET_M(5, HL); },	/* 0xee */
	function() { SET(5, A); },	/* 0xef */

	function() { SET(6, B); },	/* 0xf0 */
	function() { SET(6, C); },	/* 0xf1 */
	function() { SET(6, D); },	/* 0xf2 */
	function() { SET(6, E); },	/* 0xf3 */
	function() { SET(6, H); },	/* 0xf4 */
	function() { SET(6, L); },	/* 0xf5 */
	function() { SET_M(6, HL); },	/* 0xf6 */
	function() { SET(6, A); },	/* 0xf7 */

	function() { SET(7, B); },	/* 0xf8 */
	function() { SET(7, C); },	/* 0xf9 */
	function() { SET(7, D); },	/* 0xfa */
	function() { SET(7, E); },	/* 0xfb */
	function() { SET(7, H); },	/* 0xfc */
	function() { SET(7, L); },	/* 0xfd */
	function() { SET_M(7, HL); },	/* 0xfe */
	function() { SET(7, A); }	/* 0xff */
);

_z80executeDDCBXX = new Array(
	function() { RLC_M_R(IX + EQ, B); },	/* 0x00 */
	function() { RLC_M_R(IX + EQ, C); },	/* 0x01 */
	function() { RLC_M_R(IX + EQ, D); },	/* 0x02 */
	function() { RLC_M_R(IX + EQ, E); },	/* 0x03 */
	function() { RLC_M_R(IX + EQ, H); },	/* 0x04 */
	function() { RLC_M_R(IX + EQ, L); },	/* 0x05 */
	function() { RLC_M(IX + EQ); },	/* 0x06 */
	function() { RLC_M_R(IX + EQ, A); },	/* 0x07 */

	function() { RRC_M_R(IX + EQ, B); },	/* 0x08 */
	function() { RRC_M_R(IX + EQ, C); },	/* 0x09 */
	function() { RRC_M_R(IX + EQ, D); },	/* 0x0a */
	function() { RRC_M_R(IX + EQ, E); },	/* 0x0b */
	function() { RRC_M_R(IX + EQ, H); },	/* 0x0c */
	function() { RRC_M_R(IX + EQ, L); },	/* 0x0d */
	function() { RRC_M(IX + EQ); },	/* 0x0e */
	function() { RRC_M_R(IX + EQ, A); },	/* 0x0f */

	function() { RL_M_R(IX + EQ, B); },	/* 0x10 */
	function() { RL_M_R(IX + EQ, C); },	/* 0x11 */
	function() { RL_M_R(IX + EQ, D); },	/* 0x12 */
	function() { RL_M_R(IX + EQ, E); },	/* 0x13 */
	function() { RL_M_R(IX + EQ, H); },	/* 0x14 */
	function() { RL_M_R(IX + EQ, L); },	/* 0x15 */
	function() { RL_M(IX + EQ); },	/* 0x16 */
	function() { RL_M_R(IX + EQ, A); },	/* 0x17 */

	function() { RR_M_R(IX + EQ, B); },	/* 0x18 */
	function() { RR_M_R(IX + EQ, C); },	/* 0x19 */
	function() { RR_M_R(IX + EQ, D); },	/* 0x1a */
	function() { RR_M_R(IX + EQ, E); },	/* 0x1b */
	function() { RR_M_R(IX + EQ, H); },	/* 0x1c */
	function() { RR_M_R(IX + EQ, L); },	/* 0x1d */
	function() { RR_M(IX + EQ); },	/* 0x1e */
	function() { RR_M_R(IX + EQ, A); },	/* 0x1f */

	function() { SLA_M_R(IX + EQ, B); },	/* 0x20 */
	function() { SLA_M_R(IX + EQ, C); },	/* 0x21 */
	function() { SLA_M_R(IX + EQ, D); },	/* 0x22 */
	function() { SLA_M_R(IX + EQ, E); },	/* 0x23 */
	function() { SLA_M_R(IX + EQ, H); },	/* 0x24 */
	function() { SLA_M_R(IX + EQ, L); },	/* 0x25 */
	function() { SLA_M(IX + EQ); },	/* 0x26 */
	function() { SLA_M_R(IX + EQ, A); },	/* 0x27 */

	function() { SRA_M_R(IX + EQ, B); },	/* 0x28 */
	function() { SRA_M_R(IX + EQ, C); },	/* 0x29 */
	function() { SRA_M_R(IX + EQ, D); },	/* 0x2a */
	function() { SRA_M_R(IX + EQ, E); },	/* 0x2b */
	function() { SRA_M_R(IX + EQ, H); },	/* 0x2c */
	function() { SRA_M_R(IX + EQ, L); },	/* 0x2d */
	function() { SRA_M(IX + EQ); },	/* 0x2e */
	function() { SRA_M_R(IX + EQ, A); },	/* 0x2f */

	function() { SLL_M_R(IX + EQ, B); },	/* 0x30 */
	function() { SLL_M_R(IX + EQ, C); },	/* 0x31 */
	function() { SLL_M_R(IX + EQ, D); },	/* 0x32 */
	function() { SLL_M_R(IX + EQ, E); },	/* 0x33 */
	function() { SLL_M_R(IX + EQ, H); },	/* 0x34 */
	function() { SLL_M_R(IX + EQ, L); },	/* 0x35 */
	function() { SLL_M(IX + EQ); },	/* 0x36 */
	function() { SLL_M_R(IX + EQ, A); },	/* 0x37 */

	function() { SRL_M_R(IX + EQ, B); },	/* 0x38 */
	function() { SRL_M_R(IX + EQ, C); },	/* 0x39 */
	function() { SRL_M_R(IX + EQ, D); },	/* 0x3a */
	function() { SRL_M_R(IX + EQ, E); },	/* 0x3b */
	function() { SRL_M_R(IX + EQ, H); },	/* 0x3c */
	function() { SRL_M_R(IX + EQ, L); },	/* 0x3d */
	function() { SRL_M(IX + EQ); },	/* 0x3e */
	function() { SRL_M_R(IX + EQ, A); },	/* 0x3f */

	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x40 */
	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x41 */
	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x42 */
	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x43 */
	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x44 */
	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x45 */
	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x46 */
	function() { BIT(0, MEM8(IX + EQ)); },	/* 0x47 */

	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x48 */
	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x49 */
	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x4a */
	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x4b */
	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x4c */
	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x4d */
	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x4e */
	function() { BIT(1, MEM8(IX + EQ)); },	/* 0x4f */

	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x50 */
	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x51 */
	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x52 */
	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x53 */
	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x54 */
	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x55 */
	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x56 */
	function() { BIT(2, MEM8(IX + EQ)); },	/* 0x57 */

	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x58 */
	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x59 */
	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x5a */
	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x5b */
	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x5c */
	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x5d */
	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x5e */
	function() { BIT(3, MEM8(IX + EQ)); },	/* 0x5f */

	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x60 */
	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x61 */
	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x62 */
	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x63 */
	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x64 */
	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x65 */
	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x66 */
	function() { BIT(4, MEM8(IX + EQ)); },	/* 0x67 */

	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x68 */
	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x69 */
	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x6a */
	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x6b */
	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x6c */
	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x6d */
	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x6e */
	function() { BIT(5, MEM8(IX + EQ)); },	/* 0x6f */

	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x70 */
	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x71 */
	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x72 */
	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x73 */
	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x74 */
	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x75 */
	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x76 */
	function() { BIT(6, MEM8(IX + EQ)); },	/* 0x77 */

	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x78 */
	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x79 */
	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x7a */
	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x7b */
	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x7c */
	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x7d */
	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x7e */
	function() { BIT(7, MEM8(IX + EQ)); },	/* 0x7f */

	function() { RES_M_R(0, IX + EQ, B); },	/* 0x80 */
	function() { RES_M_R(0, IX + EQ, C); },	/* 0x81 */
	function() { RES_M_R(0, IX + EQ, D); },	/* 0x82 */
	function() { RES_M_R(0, IX + EQ, E); },	/* 0x83 */
	function() { RES_M_R(0, IX + EQ, H); },	/* 0x84 */
	function() { RES_M_R(0, IX + EQ, L); },	/* 0x85 */
	function() { RES_M(0, IX + EQ); },	/* 0x86 */
	function() { RES_M_R(0, IX + EQ, A); },	/* 0x87 */

	function() { RES_M_R(1, IX + EQ, B); },	/* 0x88 */
	function() { RES_M_R(1, IX + EQ, C); },	/* 0x89 */
	function() { RES_M_R(1, IX + EQ, D); },	/* 0x8a */
	function() { RES_M_R(1, IX + EQ, E); },	/* 0x8b */
	function() { RES_M_R(1, IX + EQ, H); },	/* 0x8c */
	function() { RES_M_R(1, IX + EQ, L); },	/* 0x8d */
	function() { RES_M(1, IX + EQ); },	/* 0x8e */
	function() { RES_M_R(1, IX + EQ, A); },	/* 0x8f */

	function() { RES_M_R(2, IX + EQ, B); },	/* 0x90 */
	function() { RES_M_R(2, IX + EQ, C); },	/* 0x91 */
	function() { RES_M_R(2, IX + EQ, D); },	/* 0x92 */
	function() { RES_M_R(2, IX + EQ, E); },	/* 0x93 */
	function() { RES_M_R(2, IX + EQ, H); },	/* 0x94 */
	function() { RES_M_R(2, IX + EQ, L); },	/* 0x95 */
	function() { RES_M(2, IX + EQ); },	/* 0x96 */
	function() { RES_M_R(2, IX + EQ, A); },	/* 0x97 */

	function() { RES_M_R(3, IX + EQ, B); },	/* 0x98 */
	function() { RES_M_R(3, IX + EQ, C); },	/* 0x99 */
	function() { RES_M_R(3, IX + EQ, D); },	/* 0x9a */
	function() { RES_M_R(3, IX + EQ, E); },	/* 0x9b */
	function() { RES_M_R(3, IX + EQ, H); },	/* 0x9c */
	function() { RES_M_R(3, IX + EQ, L); },	/* 0x9d */
	function() { RES_M(3, IX + EQ); },	/* 0x9e */
	function() { RES_M_R(3, IX + EQ, A); },	/* 0x9f */

	function() { RES_M_R(4, IX + EQ, B); },	/* 0xa0 */
	function() { RES_M_R(4, IX + EQ, C); },	/* 0xa1 */
	function() { RES_M_R(4, IX + EQ, D); },	/* 0xa2 */
	function() { RES_M_R(4, IX + EQ, E); },	/* 0xa3 */
	function() { RES_M_R(4, IX + EQ, H); },	/* 0xa4 */
	function() { RES_M_R(4, IX + EQ, L); },	/* 0xa5 */
	function() { RES_M(4, IX + EQ); },	/* 0xa6 */
	function() { RES_M_R(4, IX + EQ, A); },	/* 0xa7 */

	function() { RES_M_R(5, IX + EQ, B); },	/* 0xa8 */
	function() { RES_M_R(5, IX + EQ, C); },	/* 0xa9 */
	function() { RES_M_R(5, IX + EQ, D); },	/* 0xaa */
	function() { RES_M_R(5, IX + EQ, E); },	/* 0xab */
	function() { RES_M_R(5, IX + EQ, H); },	/* 0xac */
	function() { RES_M_R(5, IX + EQ, L); },	/* 0xad */
	function() { RES_M(5, IX + EQ); },	/* 0xae */
	function() { RES_M_R(5, IX + EQ, A); },	/* 0xaf */

	function() { RES_M_R(6, IX + EQ, B); },	/* 0xb0 */
	function() { RES_M_R(6, IX + EQ, C); },	/* 0xb1 */
	function() { RES_M_R(6, IX + EQ, D); },	/* 0xb2 */
	function() { RES_M_R(6, IX + EQ, E); },	/* 0xb3 */
	function() { RES_M_R(6, IX + EQ, H); },	/* 0xb4 */
	function() { RES_M_R(6, IX + EQ, L); },	/* 0xb5 */
	function() { RES_M(6, IX + EQ); },	/* 0xb6 */
	function() { RES_M_R(6, IX + EQ, A); },	/* 0xb7 */

	function() { RES_M_R(7, IX + EQ, B); },	/* 0xb8 */
	function() { RES_M_R(7, IX + EQ, C); },	/* 0xb9 */
	function() { RES_M_R(7, IX + EQ, D); },	/* 0xba */
	function() { RES_M_R(7, IX + EQ, E); },	/* 0xbb */
	function() { RES_M_R(7, IX + EQ, H); },	/* 0xbc */
	function() { RES_M_R(7, IX + EQ, L); },	/* 0xbd */
	function() { RES_M(7, IX + EQ); },	/* 0xbe */
	function() { RES_M_R(7, IX + EQ, A); },	/* 0xbf */

	function() { SET_M_R(0, IX + EQ, B); },	/* 0xc0 */
	function() { SET_M_R(0, IX + EQ, C); },	/* 0xc1 */
	function() { SET_M_R(0, IX + EQ, D); },	/* 0xc2 */
	function() { SET_M_R(0, IX + EQ, E); },	/* 0xc3 */
	function() { SET_M_R(0, IX + EQ, H); },	/* 0xc4 */
	function() { SET_M_R(0, IX + EQ, L); },	/* 0xc5 */
	function() { SET_M(0, IX + EQ); },	/* 0xc6 */
	function() { SET_M_R(0, IX + EQ, A); },	/* 0xc7 */

	function() { SET_M_R(1, IX + EQ, B); },	/* 0xc8 */
	function() { SET_M_R(1, IX + EQ, C); },	/* 0xc9 */
	function() { SET_M_R(1, IX + EQ, D); },	/* 0xca */
	function() { SET_M_R(1, IX + EQ, E); },	/* 0xcb */
	function() { SET_M_R(1, IX + EQ, H); },	/* 0xcc */
	function() { SET_M_R(1, IX + EQ, L); },	/* 0xcd */
	function() { SET_M(1, IX + EQ); },	/* 0xce */
	function() { SET_M_R(1, IX + EQ, A); },	/* 0xcf */

	function() { SET_M_R(2, IX + EQ, B); },	/* 0xd0 */
	function() { SET_M_R(2, IX + EQ, C); },	/* 0xd1 */
	function() { SET_M_R(2, IX + EQ, D); },	/* 0xd2 */
	function() { SET_M_R(2, IX + EQ, E); },	/* 0xd3 */
	function() { SET_M_R(2, IX + EQ, H); },	/* 0xd4 */
	function() { SET_M_R(2, IX + EQ, L); },	/* 0xd5 */
	function() { SET_M(2, IX + EQ); },	/* 0xd6 */
	function() { SET_M_R(2, IX + EQ, A); },	/* 0xd7 */

	function() { SET_M_R(3, IX + EQ, B); },	/* 0xd8 */
	function() { SET_M_R(3, IX + EQ, C); },	/* 0xd9 */
	function() { SET_M_R(3, IX + EQ, D); },	/* 0xda */
	function() { SET_M_R(3, IX + EQ, E); },	/* 0xdb */
	function() { SET_M_R(3, IX + EQ, H); },	/* 0xdc */
	function() { SET_M_R(3, IX + EQ, L); },	/* 0xdd */
	function() { SET_M(3, IX + EQ); },	/* 0xde */
	function() { SET_M_R(3, IX + EQ, A); },	/* 0xdf */

	function() { SET_M_R(4, IX + EQ, B); },	/* 0xe0 */
	function() { SET_M_R(4, IX + EQ, C); },	/* 0xe1 */
	function() { SET_M_R(4, IX + EQ, D); },	/* 0xe2 */
	function() { SET_M_R(4, IX + EQ, E); },	/* 0xe3 */
	function() { SET_M_R(4, IX + EQ, H); },	/* 0xe4 */
	function() { SET_M_R(4, IX + EQ, L); },	/* 0xe5 */
	function() { SET_M(4, IX + EQ); },	/* 0xe6 */
	function() { SET_M_R(4, IX + EQ, A); },	/* 0xe7 */

	function() { SET_M_R(5, IX + EQ, B); },	/* 0xe8 */
	function() { SET_M_R(5, IX + EQ, C); },	/* 0xe9 */
	function() { SET_M_R(5, IX + EQ, D); },	/* 0xea */
	function() { SET_M_R(5, IX + EQ, E); },	/* 0xeb */
	function() { SET_M_R(5, IX + EQ, H); },	/* 0xec */
	function() { SET_M_R(5, IX + EQ, L); },	/* 0xed */
	function() { SET_M(5, IX + EQ); },	/* 0xee */
	function() { SET_M_R(5, IX + EQ, A); },	/* 0xef */

	function() { SET_M_R(6, IX + EQ, B); },	/* 0xf0 */
	function() { SET_M_R(6, IX + EQ, C); },	/* 0xf1 */
	function() { SET_M_R(6, IX + EQ, D); },	/* 0xf2 */
	function() { SET_M_R(6, IX + EQ, E); },	/* 0xf3 */
	function() { SET_M_R(6, IX + EQ, H); },	/* 0xf4 */
	function() { SET_M_R(6, IX + EQ, L); },	/* 0xf5 */
	function() { SET_M(6, IX + EQ); },	/* 0xf6 */
	function() { SET_M_R(6, IX + EQ, A); },	/* 0xf7 */

	function() { SET_M_R(7, IX + EQ, B); },	/* 0xf8 */
	function() { SET_M_R(7, IX + EQ, C); },	/* 0xf9 */
	function() { SET_M_R(7, IX + EQ, D); },	/* 0xfa */
	function() { SET_M_R(7, IX + EQ, E); },	/* 0xfb */
	function() { SET_M_R(7, IX + EQ, H); },	/* 0xfc */
	function() { SET_M_R(7, IX + EQ, L); },	/* 0xfd */
	function() { SET_M(7, IX + EQ); },	/* 0xfe */
	function() { SET_M_R(7, IX + EQ, A); }	/* 0xff */
);

_z80executeDDXX = new Array(
	function() { NOP(); },	/* 0x00 */
	function() { NOP(); },	/* 0x01 */
	function() { NOP(); },	/* 0x02 */
	function() { NOP(); },	/* 0x03 */
	function() { NOP(); },	/* 0x04 */
	function() { NOP(); },	/* 0x05 */
	function() { NOP(); },	/* 0x06 */
	function() { NOP(); },	/* 0x07 */

	function() { NOP(); },	/* 0x08 */
	function() { ADD16(IX, BC); },	/* 0x09 */
	function() { NOP(); },	/* 0x0a */
	function() { NOP(); },	/* 0x0b */
	function() { NOP(); },	/* 0x0c */
	function() { NOP(); },	/* 0x0d */
	function() { NOP(); },	/* 0x0e */
	function() { NOP(); },	/* 0x0f */

	function() { NOP(); },	/* 0x10 */
	function() { NOP(); },	/* 0x11 */
	function() { NOP(); },	/* 0x12 */
	function() { NOP(); },	/* 0x13 */
	function() { NOP(); },	/* 0x14 */
	function() { NOP(); },	/* 0x15 */
	function() { NOP(); },	/* 0x16 */
	function() { NOP(); },	/* 0x17 */

	function() { NOP(); },	/* 0x18 */
	function() { ADD16(IX, DE); },	/* 0x19 */
	function() { NOP(); },	/* 0x1a */
	function() { NOP(); },	/* 0x1b */
	function() { NOP(); },	/* 0x1c */
	function() { NOP(); },	/* 0x1d */
	function() { NOP(); },	/* 0x1e */
	function() { NOP(); },	/* 0x1f */

	function() { NOP(); },	/* 0x20 */
	function() { LD16(IX, IMM16); },	/* 0x21 */
	function() { ST16(IMM16, IX); },	/* 0x22 */
	function() { INC16(IX); },	/* 0x23 */
	function() { INC8(IXH); },	/* 0x24 */
	function() { DEC8(IXH); },	/* 0x25 */
	function() { LD(IXH, IMM8); },	/* 0x26 */
	function() { NOP(); },	/* 0x27 */

	function() { NOP(); },	/* 0x28 */
	function() { ADD16(IX, IX); },	/* 0x29 */
	function() { LD16(IX, MEM16(IMM16)); },	/* 0x2a */
	function() { DEC16(IX); },	/* 0x2b */
	function() { INC8(IXL); },	/* 0x2c */
	function() { DEC8(IXL); },	/* 0x2d */
	function() { LD(IXL, IMM8); },	/* 0x2e */
	function() { NOP(); },	/* 0x2f */

	function() { NOP(); },	/* 0x30 */
	function() { NOP(); },	/* 0x31 */
	function() { NOP(); },	/* 0x32 */
	function() { NOP(); },	/* 0x33 */
	function() { INC8_M(IX + EQ); }, /* 0x34 */
	function() { DEC8_M(IX + EQ); }, /* 0x35 */
	function() { ST8(IX + EQ, MEM8(PC + 2)); }, /* 0x36 */
	function() { NOP(); },	/* 0x37 */

	function() { NOP(); },	/* 0x38 */
	function() { ADD16(IX, SP); }, /* 0x39 */
	function() { NOP(); },	/* 0x3a */
	function() { NOP(); },	/* 0x3b */
	function() { NOP(); },	/* 0x3c */
	function() { NOP(); },	/* 0x3d */
	function() { NOP(); },	/* 0x3e */
	function() { NOP(); },	/* 0x3f */

	function() { NOP(); },	/* 0x40 */
	function() { NOP(); },	/* 0x41 */
	function() { NOP(); },	/* 0x42 */
	function() { NOP(); },	/* 0x43 */
	function() { LD(B, IXH); },	/* 0x44 */
	function() { LD(B, IXL); },	/* 0x45 */
	function() { LD(B, MEM8(IX + EQ)); },	/* 0x46 */
	function() { NOP(); },	/* 0x47 */

	function() { NOP(); },	/* 0x48 */
	function() { NOP(); },	/* 0x49 */
	function() { NOP(); },	/* 0x4a */
	function() { NOP(); },	/* 0x4b */
	function() { LD(C, IXH); },	/* 0x4c */
	function() { LD(C, IXL); },	/* 0x4d */
	function() { LD(C, MEM8(IX + EQ)); },	/* 0x4e */
	function() { NOP(); },	/* 0x4f */

	function() { NOP(); },	/* 0x50 */
	function() { NOP(); },	/* 0x51 */
	function() { NOP(); },	/* 0x52 */
	function() { NOP(); },	/* 0x53 */
	function() { LD(D, IXH); },	/* 0x54 */
	function() { LD(D, IXL); },	/* 0x55 */
	function() { LD(D, MEM8(IX + EQ)); },	/* 0x56 */
	function() { NOP(); },	/* 0x57 */

	function() { NOP(); },	/* 0x58 */
	function() { NOP(); },	/* 0x59 */
	function() { NOP(); },	/* 0x5a */
	function() { NOP(); },	/* 0x5b */
	function() { LD(E, IXH); },	/* 0x5c */
	function() { LD(E, IXL); },	/* 0x5d */
	function() { LD(E, MEM8(IX + EQ)); },	/* 0x5e */
	function() { NOP(); },	/* 0x5f */

	function() { LD(IXH, B); },	/* 0x60 */
	function() { LD(IXH, C); },	/* 0x61 */
	function() { LD(IXH, D); },	/* 0x62 */
	function() { LD(IXH, E); },	/* 0x63 */
	function() { LD(IXH, H); },	/* 0x64 */
	function() { LD(IXH, L); },	/* 0x65 */
	function() { LD(H, MEM8(IX + EQ)); },	/* 0x66 */
	function() { LD(IXH, A); },	/* 0x67 */

	function() { LD(IXL, B); },	/* 0x68 */
	function() { LD(IXL, C); },	/* 0x69 */
	function() { LD(IXL, D); },	/* 0x6a */
	function() { LD(IXL, E); },	/* 0x6b */
	function() { LD(IXL, H); },	/* 0x6c */
	function() { LD(IXL, L); },	/* 0x6d */
	function() { LD(L, MEM8(IX + EQ)); },	/* 0x6e */
	function() { LD(IXL, A); },	/* 0x6f */

	function() { ST8(IX + EQ, B); },	/* 0x70 */
	function() { ST8(IX + EQ, C); },	/* 0x71 */
	function() { ST8(IX + EQ, D); },	/* 0x72 */
	function() { ST8(IX + EQ, E); },	/* 0x73 */
	function() { ST8(IX + EQ, H); },	/* 0x74 */
	function() { ST8(IX + EQ, L); },	/* 0x75 */
	function() { NOP(); },	/* 0x76 */
	function() { ST8(IX + EQ, A); },	/* 0x77 */

	function() { NOP(); },	/* 0x78 */
	function() { NOP(); },	/* 0x79 */
	function() { NOP(); },	/* 0x7a */
	function() { NOP(); },	/* 0x7b */
	function() { LD(A, IXH); },	/* 0x7c */
	function() { LD(A, IXL); },	/* 0x7d */
	function() { LD(A, MEM8(IX + EQ)); },	/* 0x7e */
	function() { NOP(); },	/* 0x7f */

	function() { NOP(); },	/* 0x80 */
	function() { NOP(); },	/* 0x81 */
	function() { NOP(); },	/* 0x82 */
	function() { NOP(); },	/* 0x83 */
	function() { ADD8(IXH); },	/* 0x84 */
	function() { ADD8(IXL); },	/* 0x85 */
	function() { ADD8(MEM8(IX + EQ)); },	/* 0x86 */
	function() { NOP(); },	/* 0x87 */

	function() { NOP(); },	/* 0x88 */
	function() { NOP(); },	/* 0x89 */
	function() { NOP(); },	/* 0x8a */
	function() { NOP(); },	/* 0x8b */
	function() { ADC8(IXH); },	/* 0x8c */
	function() { ADC8(IXL); },	/* 0x8d */
	function() { ADC8(MEM8(IX + EQ)); },	/* 0x8e */
	function() { NOP(); },	/* 0x8f */

	function() { NOP(); },	/* 0x90 */
	function() { NOP(); },	/* 0x91 */
	function() { NOP(); },	/* 0x92 */
	function() { NOP(); },	/* 0x93 */
	function() { SUB8(IXH); },	/* 0x94 */
	function() { SUB8(IXL); },	/* 0x95 */
	function() { SUB8(MEM8(IX + EQ)); },	/* 0x96 */
	function() { NOP(); },	/* 0x97 */

	function() { NOP(); },	/* 0x98 */
	function() { NOP(); },	/* 0x99 */
	function() { NOP(); },	/* 0x9a */
	function() { NOP(); },	/* 0x9b */
	function() { SBC8(IXH); },	/* 0x9c */
	function() { SBC8(IXL); },	/* 0x9d */
	function() { SBC8(MEM8(IX + EQ)); },	/* 0x9e */
	function() { NOP(); },	/* 0x9f */

	function() { NOP(); },	/* 0xa0 */
	function() { NOP(); },	/* 0xa1 */
	function() { NOP(); },	/* 0xa2 */
	function() { NOP(); },	/* 0xa3 */
	function() { AND(IXH); },	/* 0xa4 */
	function() { AND(IXL); },	/* 0xa5 */
	function() { AND(MEM8(IX + EQ)); },	/* 0xa6 */
	function() { NOP(); },	/* 0xa7 */

	function() { NOP(); },	/* 0xa8 */
	function() { NOP(); },	/* 0xa9 */
	function() { NOP(); },	/* 0xaa */
	function() { NOP(); },	/* 0xab */
	function() { XOR(IXH); },	/* 0xac */
	function() { XOR(IXL); },	/* 0xad */
	function() { XOR(MEM8(IX + EQ)); },	/* 0xae */
	function() { NOP(); },	/* 0xaf */

	function() { NOP(); },	/* 0xb0 */
	function() { NOP(); },	/* 0xb1 */
	function() { NOP(); },	/* 0xb2 */
	function() { NOP(); },	/* 0xb3 */
	function() { OR(IXH); },	/* 0xb4 */
	function() { OR(IXL); },	/* 0xb5 */
	function() { OR(MEM8(IX + EQ)); },	/* 0xb6 */
	function() { NOP(); },	/* 0xb7 */

	function() { NOP(); },	/* 0xb8 */
	function() { NOP(); },	/* 0xb9 */
	function() { NOP(); },	/* 0xba */
	function() { NOP(); },	/* 0xbb */
	function() { CP(IXH); },	/* 0xbc */
	function() { CP(IXL); },	/* 0xbd */
	function() { CP(MEM8(IX + EQ)); },	/* 0xbe */
	function() { NOP(); },	/* 0xbf */

	function() { NOP(); },	/* 0xc0 */
	function() { NOP(); },	/* 0xc1 */
	function() { NOP(); },	/* 0xc2 */
	function() { NOP(); },	/* 0xc3 */
	function() { NOP(); },	/* 0xc4 */
	function() { NOP(); },	/* 0xc5 */
	function() { NOP(); },	/* 0xc6 */
	function() { NOP(); },	/* 0xc7 */

	function() { NOP(); },	/* 0xc8 */
	function() { NOP(); },	/* 0xc9 */
	function() { NOP(); },	/* 0xca */
	function() { var op = MEM8(PC + 2); _state = _stateDDCBXX[op]; _length = _lengthDDCBXX[op]; _z80executeDDCBXX[op](); },	/* 0xcb */
	function() { NOP(); },	/* 0xcc */
	function() { NOP(); },	/* 0xcd */
	function() { NOP(); },	/* 0xce */
	function() { NOP(); },	/* 0xcf */

	function() { NOP(); },	/* 0xd0 */
	function() { NOP(); },	/* 0xd1 */
	function() { NOP(); },	/* 0xd2 */
	function() { NOP(); },	/* 0xd3 */
	function() { NOP(); },	/* 0xd4 */
	function() { NOP(); },	/* 0xd5 */
	function() { NOP(); },	/* 0xd6 */
	function() { NOP(); },	/* 0xd7 */

	function() { NOP(); },	/* 0xd8 */
	function() { NOP(); },	/* 0xd9 */
	function() { NOP(); },	/* 0xda */
	function() { NOP(); },	/* 0xdb */
	function() { NOP(); },	/* 0xdc */
	function() { NOP(); },	/* 0xdd */
	function() { NOP(); },	/* 0xde */
	function() { NOP(); },	/* 0xdf */

	function() { NOP(); },	/* 0xe0 */
	function() { POP(IX); },	/* 0xe1 */
	function() { NOP(); },	/* 0xe2 */
	function() { EX_M(SP, IX); },	/* 0xe3 */
	function() { NOP(); },	/* 0xe4 */
	function() { PUSH(IX); },	/* 0xe5 */
	function() { NOP(); },	/* 0xe6 */
	function() { NOP(); },	/* 0xe7 */

	function() { NOP(); },	/* 0xe8 */
	function() { JP(true, IX); },	/* 0xe9 */
	function() { NOP(); },	/* 0xea */
	function() { NOP(); },	/* 0xeb */
	function() { NOP(); },	/* 0xec */
	function() { NOP(); },	/* 0xed */
	function() { NOP(); },	/* 0xee */
	function() { NOP(); },	/* 0xef */

	function() { NOP(); },	/* 0xf0 */
	function() { NOP(); },	/* 0xf1 */
	function() { NOP(); },	/* 0xf2 */
	function() { NOP(); },	/* 0xf3 */
	function() { NOP(); },	/* 0xf4 */
	function() { NOP(); },	/* 0xf5 */
	function() { NOP(); },	/* 0xf6 */
	function() { NOP(); },	/* 0xf7 */

	function() { NOP(); },	/* 0xf8 */
	function() { LD16(SP, IX); },	/* 0xf9 */
	function() { NOP(); },	/* 0xfa */
	function() { NOP(); },	/* 0xfb */
	function() { NOP(); },	/* 0xfc */
	function() { NOP(); },	/* 0xfd */
	function() { NOP(); },	/* 0xfe */
	function() { NOP(); }	/* 0xff */
);

_z80executeEDXX = new Array(
	function() { NOP(); },	/* 0x00 */
	function() { NOP(); },	/* 0x01 */
	function() { NOP(); },	/* 0x02 */
	function() { NOP(); },	/* 0x03 */
	function() { NOP(); },	/* 0x04 */
	function() { NOP(); },	/* 0x05 */
	function() { NOP(); },	/* 0x06 */
	function() { NOP(); },	/* 0x07 */

	function() { NOP(); },	/* 0x08 */
	function() { NOP(); },	/* 0x09 */
	function() { NOP(); },	/* 0x0a */
	function() { NOP(); },	/* 0x0b */
	function() { NOP(); },	/* 0x0c */
	function() { NOP(); },	/* 0x0d */
	function() { NOP(); },	/* 0x0e */
	function() { NOP(); },	/* 0x0f */

	function() { NOP(); },	/* 0x10 */
	function() { NOP(); },	/* 0x11 */
	function() { NOP(); },	/* 0x12 */
	function() { NOP(); },	/* 0x13 */
	function() { NOP(); },	/* 0x14 */
	function() { NOP(); },	/* 0x15 */
	function() { NOP(); },	/* 0x16 */
	function() { NOP(); },	/* 0x17 */

	function() { NOP(); },	/* 0x18 */
	function() { NOP(); },	/* 0x19 */
	function() { NOP(); },	/* 0x1a */
	function() { NOP(); },	/* 0x1b */
	function() { NOP(); },	/* 0x1c */
	function() { NOP(); },	/* 0x1d */
	function() { NOP(); },	/* 0x1e */
	function() { NOP(); },	/* 0x1f */

	function() { NOP(); },	/* 0x20 */
	function() { NOP(); },	/* 0x21 */
	function() { NOP(); },	/* 0x22 */
	function() { NOP(); },	/* 0x23 */
	function() { NOP(); },	/* 0x24 */
	function() { NOP(); },	/* 0x25 */
	function() { NOP(); },	/* 0x26 */
	function() { NOP(); },	/* 0x27 */

	function() { NOP(); },	/* 0x28 */
	function() { NOP(); },	/* 0x29 */
	function() { NOP(); },	/* 0x2a */
	function() { NOP(); },	/* 0x2b */
	function() { NOP(); },	/* 0x2c */
	function() { NOP(); },	/* 0x2d */
	function() { NOP(); },	/* 0x2e */
	function() { NOP(); },	/* 0x2f */

	function() { NOP(); },	/* 0x30 */
	function() { NOP(); },	/* 0x31 */
	function() { NOP(); },	/* 0x32 */
	function() { NOP(); },	/* 0x33 */
	function() { NOP(); },	/* 0x34 */
	function() { NOP(); },	/* 0x35 */
	function() { NOP(); },	/* 0x36 */
	function() { NOP(); },	/* 0x37 */

	function() { NOP(); },	/* 0x38 */
	function() { NOP(); },	/* 0x39 */
	function() { NOP(); },	/* 0x3a */
	function() { NOP(); },	/* 0x3b */
	function() { NOP(); },	/* 0x3c */
	function() { NOP(); },	/* 0x3d */
	function() { NOP(); },	/* 0x3e */
	function() { NOP(); },	/* 0x3f */

	function() { IN_C(B, C); },	/* 0x40 */
	function() { OUT(C, B); },	/* 0x41 */
	function() { SBC16(HL, BC); },	/* 0x42 */
	function() { ST16(IMM16, BC); },	/* 0x43 */
	function() { NEG(); },	/* 0x44 */
	function() { RETN(); },	/* 0x45 */
	function() { IM(0); },	/* 0x46 */
	function() { LD(I, A); },	/* 0x47 */

	function() { IN_C(C, C); },	/* 0x48 */
	function() { OUT(C, C); },	/* 0x49 */
	function() { ADC16(HL, BC); },	/* 0x4a */
	function() { LD16(BC, MEM16(IMM16)); },	/* 0x4b */
	function() { NEG(); },	/* 0x4c */
	function() { RETI(); },	/* 0x4d */
	function() { IM(0); },	/* 0x4e */
	function() { NOP(); },	/* 0x4f */

	function() { IN_C(D, C); },	/* 0x50 */
	function() { OUT(C, D); },	/* 0x51 */
	function() { SBC16(HL, DE); },	/* 0x52 */
	function() { ST16(IMM16, DE); },	/* 0x53 */
	function() { NEG(); },	/* 0x54 */
	function() { RETN(); },	/* 0x55 */
	function() { IM(1); },	/* 0x56 */
	function() { LD_A_I(); },	/* 0x57 */

	function() { IN_C(E, C); },	/* 0x58 */
	function() { OUT(C, E); },	/* 0x59 */
	function() { ADC16(HL, DE); },	/* 0x5a */
	function() { LD16(DE, MEM16(IMM16)); },	/* 0x5b */
	function() { NEG(); },	/* 0x5c */
	function() { RETN(); },	/* 0x5d */
	function() { IM(2); },	/* 0x5e */
	function() { LD_A_R(); },	/* 0x5f */

	function() { IN_C(H, C); },	/* 0x60 */
	function() { OUT(C, H); },	/* 0x61 */
	function() { SBC16(HL, HL); },	/* 0x62 */
	function() { ST16(IMM16, HL); },	/* 0x63 */
	function() { NEG(); },	/* 0x64 */
	function() { RETN(); },	/* 0x65 */
	function() { IM(0); },	/* 0x66 */
	function() { RRD(); },	/* 0x67 */

	function() { IN_C(L, C); },	/* 0x68 */
	function() { OUT(C, L); },	/* 0x69 */
	function() { ADC16(HL, HL); },	/* 0x6a */
	function() { LD16(HL, MEM16(IMM16)); },	/* 0x6b */
	function() { NEG(); },	/* 0x6c */
	function() { RETN(); },	/* 0x6d */
	function() { IM(0); },	/* 0x6e */
	function() { RLD(); },	/* 0x6f */

	function() { IN_C(F, C); },	/* 0x70 */
	function() { OUT(C, 0); },	/* 0x71 */
	function() { SBC16(HL, SP); },	/* 0x72 */
	function() { ST16(IMM16, SP); },	/* 0x73 */
	function() { NEG(); },	/* 0x74 */
	function() { RETN(); },	/* 0x75 */
	function() { IM(1); },	/* 0x76 */
	function() { NOP(); },	/* 0x77 */

	function() { IN_C(A, C); },	/* 0x78 */
	function() { OUT(C, A); },	/* 0x79 */
	function() { ADC16(HL, SP); },	/* 0x7a */
	function() { LD16(SP, MEM16(IMM16)); },	/* 0x7b */
	function() { NEG(); },	/* 0x7c */
	function() { RETN(); },	/* 0x7d */
	function() { IM(2); },	/* 0x7e */
	function() { NOP(); },	/* 0x7f */

	function() { NOP(); },	/* 0x80 */
	function() { NOP(); },	/* 0x81 */
	function() { NOP(); },	/* 0x82 */
	function() { NOP(); },	/* 0x83 */
	function() { NOP(); },	/* 0x84 */
	function() { NOP(); },	/* 0x85 */
	function() { NOP(); },	/* 0x86 */
	function() { NOP(); },	/* 0x87 */

	function() { NOP(); },	/* 0x88 */
	function() { NOP(); },	/* 0x89 */
	function() { NOP(); },	/* 0x8a */
	function() { NOP(); },	/* 0x8b */
	function() { NOP(); },	/* 0x8c */
	function() { NOP(); },	/* 0x8d */
	function() { NOP(); },	/* 0x8e */
	function() { NOP(); },	/* 0x8f */

	function() { NOP(); },	/* 0x90 */
	function() { NOP(); },	/* 0x91 */
	function() { NOP(); },	/* 0x92 */
	function() { NOP(); },	/* 0x93 */
	function() { NOP(); },	/* 0x94 */
	function() { NOP(); },	/* 0x95 */
	function() { NOP(); },	/* 0x96 */
	function() { NOP(); },	/* 0x97 */

	function() { NOP(); },	/* 0x98 */
	function() { NOP(); },	/* 0x99 */
	function() { NOP(); },	/* 0x9a */
	function() { NOP(); },	/* 0x9b */
	function() { NOP(); },	/* 0x9c */
	function() { NOP(); },	/* 0x9d */
	function() { NOP(); },	/* 0x9e */
	function() { NOP(); },	/* 0x9f */

	function() { LDI(); },	/* 0xa0 */
	function() { CPI(); },	/* 0xa1 */
	function() { INI(); },	/* 0xa2 */
	function() { OUTI() },	/* 0xa3 */
	function() { NOP(); },	/* 0xa4 */
	function() { NOP(); },	/* 0xa5 */
	function() { NOP(); },	/* 0xa6 */
	function() { NOP(); },	/* 0xa7 */

	function() { LDD(); },	/* 0xa8 */
	function() { CPD(); },	/* 0xa9 */
	function() { IND(); },	/* 0xaa */
	function() { OUTD(); },	/* 0xab */
	function() { NOP(); },	/* 0xac */
	function() { NOP(); },	/* 0xad */
	function() { NOP(); },	/* 0xae */
	function() { NOP(); },	/* 0xaf */

	function() { LDIR(); },	/* 0xb0 */
	function() { CPIR(); },	/* 0xb1 */
	function() { INIR(); },	/* 0xb2 */
	function() { OTIR(); },	/* 0xb3 */
	function() { NOP(); },	/* 0xb4 */
	function() { NOP(); },	/* 0xb5 */
	function() { NOP(); },	/* 0xb6 */
	function() { NOP(); },	/* 0xb7 */

	function() { LDDR(); },	/* 0xb8 */
	function() { CPDR(); },	/* 0xb9 */
	function() { INDR(); },	/* 0xba */
	function() { OTDR(); },	/* 0xbb */
	function() { NOP(); },	/* 0xbc */
	function() { NOP(); },	/* 0xbd */
	function() { NOP(); },	/* 0xbe */
	function() { NOP(); },	/* 0xbf */

	function() { NOP(); },	/* 0xc0 */
	function() { NOP(); },	/* 0xc1 */
	function() { NOP(); },	/* 0xc2 */
	function() { NOP(); },	/* 0xc3 */
	function() { NOP(); },	/* 0xc4 */
	function() { NOP(); },	/* 0xc5 */
	function() { NOP(); },	/* 0xc6 */
	function() { NOP(); },	/* 0xc7 */

	function() { NOP(); },	/* 0xc8 */
	function() { NOP(); },	/* 0xc9 */
	function() { NOP(); },	/* 0xca */
	function() { NOP(); },	/* 0xcb */
	function() { NOP(); },	/* 0xcc */
	function() { NOP(); },	/* 0xcd */
	function() { NOP(); },	/* 0xce */
	function() { NOP(); },	/* 0xcf */

	function() { NOP(); },	/* 0xd0 */
	function() { NOP(); },	/* 0xd1 */
	function() { NOP(); },	/* 0xd2 */
	function() { NOP(); },	/* 0xd3 */
	function() { NOP(); },	/* 0xd4 */
	function() { NOP(); },	/* 0xd5 */
	function() { NOP(); },	/* 0xd6 */
	function() { NOP(); },	/* 0xd7 */

	function() { NOP(); },	/* 0xd8 */
	function() { NOP(); },	/* 0xd9 */
	function() { NOP(); },	/* 0xda */
	function() { NOP(); },	/* 0xdb */
	function() { NOP(); },	/* 0xdc */
	function() { NOP(); },	/* 0xdd */
	function() { NOP(); },	/* 0xde */
	function() { NOP(); },	/* 0xdf */

	function() { NOP(); },	/* 0xe0 */
	function() { NOP(); },	/* 0xe1 */
	function() { NOP(); },	/* 0xe2 */
	function() { NOP(); },	/* 0xe3 */
	function() { NOP(); },	/* 0xe4 */
	function() { NOP(); },	/* 0xe5 */
	function() { NOP(); },	/* 0xe6 */
	function() { NOP(); },	/* 0xe7 */

	function() { NOP(); },	/* 0xe8 */
	function() { NOP(); },	/* 0xe9 */
	function() { NOP(); },	/* 0xea */
	function() { NOP(); },	/* 0xeb */
	function() { NOP(); },	/* 0xec */
	function() { NOP(); },	/* 0xed */
	function() { NOP(); },	/* 0xee */
	function() { NOP(); },	/* 0xef */

	function() { NOP(); },	/* 0xf0 */
	function() { NOP(); },	/* 0xf1 */
	function() { NOP(); },	/* 0xf2 */
	function() { NOP(); },	/* 0xf3 */
	function() { NOP(); },	/* 0xf4 */
	function() { NOP(); },	/* 0xf5 */
	function() { NOP(); },	/* 0xf6 */
	function() { NOP(); },	/* 0xf7 */

	function() { NOP(); },	/* 0xf8 */
	function() { NOP(); },	/* 0xf9 */
	function() { NOP(); },	/* 0xfa */
	function() { NOP(); },	/* 0xfb */
	function() { NOP(); },	/* 0xfc */
	function() { NOP(); },	/* 0xfd */
	function() { NOP(); },	/* 0xfe */
	function() { NOP(); }	/* 0xff */
);

_z80executeFDCBXX = new Array(
	function() { RLC_M_R(IY + EQ, B); },	/* 0x00 */
	function() { RLC_M_R(IY + EQ, C); },	/* 0x01 */
	function() { RLC_M_R(IY + EQ, D); },	/* 0x02 */
	function() { RLC_M_R(IY + EQ, E); },	/* 0x03 */
	function() { RLC_M_R(IY + EQ, H); },	/* 0x04 */
	function() { RLC_M_R(IY + EQ, L); },	/* 0x05 */
	function() { RLC_M(IY + EQ); },	/* 0x06 */
	function() { RLC_M_R(IY + EQ, A); },	/* 0x07 */

	function() { RRC_M_R(IY + EQ, B); },	/* 0x08 */
	function() { RRC_M_R(IY + EQ, C); },	/* 0x09 */
	function() { RRC_M_R(IY + EQ, D); },	/* 0x0a */
	function() { RRC_M_R(IY + EQ, E); },	/* 0x0b */
	function() { RRC_M_R(IY + EQ, H); },	/* 0x0c */
	function() { RRC_M_R(IY + EQ, L); },	/* 0x0d */
	function() { RRC_M(IY + EQ); },	/* 0x0e */
	function() { RRC_M_R(IY + EQ, A); },	/* 0x0f */

	function() { RL_M_R(IY + EQ, B); },	/* 0x10 */
	function() { RL_M_R(IY + EQ, C); },	/* 0x11 */
	function() { RL_M_R(IY + EQ, D); },	/* 0x12 */
	function() { RL_M_R(IY + EQ, E); },	/* 0x13 */
	function() { RL_M_R(IY + EQ, H); },	/* 0x14 */
	function() { RL_M_R(IY + EQ, L); },	/* 0x15 */
	function() { RL_M(IY + EQ); },	/* 0x16 */
	function() { RL_M_R(IY + EQ, A); },	/* 0x17 */

	function() { RR_M_R(IY + EQ, B); },	/* 0x18 */
	function() { RR_M_R(IY + EQ, C); },	/* 0x19 */
	function() { RR_M_R(IY + EQ, D); },	/* 0x1a */
	function() { RR_M_R(IY + EQ, E); },	/* 0x1b */
	function() { RR_M_R(IY + EQ, H); },	/* 0x1c */
	function() { RR_M_R(IY + EQ, L); },	/* 0x1d */
	function() { RR_M(IY + EQ); },	/* 0x1e */
	function() { RR_M_R(IY + EQ, A); },	/* 0x1f */

	function() { SLA_M_R(IY + EQ, B); },	/* 0x20 */
	function() { SLA_M_R(IY + EQ, C); },	/* 0x21 */
	function() { SLA_M_R(IY + EQ, D); },	/* 0x22 */
	function() { SLA_M_R(IY + EQ, E); },	/* 0x23 */
	function() { SLA_M_R(IY + EQ, H); },	/* 0x24 */
	function() { SLA_M_R(IY + EQ, L); },	/* 0x25 */
	function() { SLA_M(IY + EQ); },	/* 0x26 */
	function() { SLA_M_R(IY + EQ, A); },	/* 0x27 */

	function() { SRA_M_R(IY + EQ, B); },	/* 0x28 */
	function() { SRA_M_R(IY + EQ, C); },	/* 0x29 */
	function() { SRA_M_R(IY + EQ, D); },	/* 0x2a */
	function() { SRA_M_R(IY + EQ, E); },	/* 0x2b */
	function() { SRA_M_R(IY + EQ, H); },	/* 0x2c */
	function() { SRA_M_R(IY + EQ, L); },	/* 0x2d */
	function() { SRA_M(IY + EQ); },	/* 0x2e */
	function() { SRA_M_R(IY + EQ, A); },	/* 0x2f */

	function() { SLL_M_R(IY + EQ, B); },	/* 0x30 */
	function() { SLL_M_R(IY + EQ, C); },	/* 0x31 */
	function() { SLL_M_R(IY + EQ, D); },	/* 0x32 */
	function() { SLL_M_R(IY + EQ, E); },	/* 0x33 */
	function() { SLL_M_R(IY + EQ, H); },	/* 0x34 */
	function() { SLL_M_R(IY + EQ, L); },	/* 0x35 */
	function() { SLL_M(IY + EQ); },	/* 0x36 */
	function() { SLL_M_R(IY + EQ, A); },	/* 0x37 */

	function() { SRL_M_R(IY + EQ, B); },	/* 0x38 */
	function() { SRL_M_R(IY + EQ, C); },	/* 0x39 */
	function() { SRL_M_R(IY + EQ, D); },	/* 0x3a */
	function() { SRL_M_R(IY + EQ, E); },	/* 0x3b */
	function() { SRL_M_R(IY + EQ, H); },	/* 0x3c */
	function() { SRL_M_R(IY + EQ, L); },	/* 0x3d */
	function() { SRL_M(IY + EQ); },	/* 0x3e */
	function() { SRL_M_R(IY + EQ, A); },	/* 0x3f */

	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x40 */
	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x41 */
	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x42 */
	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x43 */
	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x44 */
	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x45 */
	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x46 */
	function() { BIT(0, MEM8(IY + EQ)); },	/* 0x47 */

	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x48 */
	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x49 */
	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x4a */
	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x4b */
	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x4c */
	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x4d */
	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x4e */
	function() { BIT(1, MEM8(IY + EQ)); },	/* 0x4f */

	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x50 */
	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x51 */
	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x52 */
	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x53 */
	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x54 */
	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x55 */
	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x56 */
	function() { BIT(2, MEM8(IY + EQ)); },	/* 0x57 */

	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x58 */
	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x59 */
	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x5a */
	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x5b */
	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x5c */
	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x5d */
	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x5e */
	function() { BIT(3, MEM8(IY + EQ)); },	/* 0x5f */

	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x60 */
	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x61 */
	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x62 */
	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x63 */
	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x64 */
	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x65 */
	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x66 */
	function() { BIT(4, MEM8(IY + EQ)); },	/* 0x67 */

	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x68 */
	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x69 */
	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x6a */
	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x6b */
	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x6c */
	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x6d */
	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x6e */
	function() { BIT(5, MEM8(IY + EQ)); },	/* 0x6f */

	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x70 */
	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x71 */
	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x72 */
	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x73 */
	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x74 */
	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x75 */
	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x76 */
	function() { BIT(6, MEM8(IY + EQ)); },	/* 0x77 */

	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x78 */
	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x79 */
	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x7a */
	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x7b */
	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x7c */
	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x7d */
	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x7e */
	function() { BIT(7, MEM8(IY + EQ)); },	/* 0x7f */

	function() { RES_M_R(0, IY + EQ, B); },	/* 0x80 */
	function() { RES_M_R(0, IY + EQ, C); },	/* 0x81 */
	function() { RES_M_R(0, IY + EQ, D); },	/* 0x82 */
	function() { RES_M_R(0, IY + EQ, E); },	/* 0x83 */
	function() { RES_M_R(0, IY + EQ, H); },	/* 0x84 */
	function() { RES_M_R(0, IY + EQ, L); },	/* 0x85 */
	function() { RES_M(0, IY + EQ); },	/* 0x86 */
	function() { RES_M_R(0, IY + EQ, A); },	/* 0x87 */

	function() { RES_M_R(1, IY + EQ, B); },	/* 0x88 */
	function() { RES_M_R(1, IY + EQ, C); },	/* 0x89 */
	function() { RES_M_R(1, IY + EQ, D); },	/* 0x8a */
	function() { RES_M_R(1, IY + EQ, E); },	/* 0x8b */
	function() { RES_M_R(1, IY + EQ, H); },	/* 0x8c */
	function() { RES_M_R(1, IY + EQ, L); },	/* 0x8d */
	function() { RES_M(1, IY + EQ); },	/* 0x8e */
	function() { RES_M_R(1, IY + EQ, A); },	/* 0x8f */

	function() { RES_M_R(2, IY + EQ, B); },	/* 0x90 */
	function() { RES_M_R(2, IY + EQ, C); },	/* 0x91 */
	function() { RES_M_R(2, IY + EQ, D); },	/* 0x92 */
	function() { RES_M_R(2, IY + EQ, E); },	/* 0x93 */
	function() { RES_M_R(2, IY + EQ, H); },	/* 0x94 */
	function() { RES_M_R(2, IY + EQ, L); },	/* 0x95 */
	function() { RES_M(2, IY + EQ); },	/* 0x96 */
	function() { RES_M_R(2, IY + EQ, A); },	/* 0x97 */

	function() { RES_M_R(3, IY + EQ, B); },	/* 0x98 */
	function() { RES_M_R(3, IY + EQ, C); },	/* 0x99 */
	function() { RES_M_R(3, IY + EQ, D); },	/* 0x9a */
	function() { RES_M_R(3, IY + EQ, E); },	/* 0x9b */
	function() { RES_M_R(3, IY + EQ, H); },	/* 0x9c */
	function() { RES_M_R(3, IY + EQ, L); },	/* 0x9d */
	function() { RES_M(3, IY + EQ); },	/* 0x9e */
	function() { RES_M_R(3, IY + EQ, A); },	/* 0x9f */

	function() { RES_M_R(4, IY + EQ, B); },	/* 0xa0 */
	function() { RES_M_R(4, IY + EQ, C); },	/* 0xa1 */
	function() { RES_M_R(4, IY + EQ, D); },	/* 0xa2 */
	function() { RES_M_R(4, IY + EQ, E); },	/* 0xa3 */
	function() { RES_M_R(4, IY + EQ, H); },	/* 0xa4 */
	function() { RES_M_R(4, IY + EQ, L); },	/* 0xa5 */
	function() { RES_M(4, IY + EQ); },	/* 0xa6 */
	function() { RES_M_R(4, IY + EQ, A); },	/* 0xa7 */

	function() { RES_M_R(5, IY + EQ, B); },	/* 0xa8 */
	function() { RES_M_R(5, IY + EQ, C); },	/* 0xa9 */
	function() { RES_M_R(5, IY + EQ, D); },	/* 0xaa */
	function() { RES_M_R(5, IY + EQ, E); },	/* 0xab */
	function() { RES_M_R(5, IY + EQ, H); },	/* 0xac */
	function() { RES_M_R(5, IY + EQ, L); },	/* 0xad */
	function() { RES_M(5, IY + EQ); },	/* 0xae */
	function() { RES_M_R(5, IY + EQ, A); },	/* 0xaf */

	function() { RES_M_R(6, IY + EQ, B); },	/* 0xb0 */
	function() { RES_M_R(6, IY + EQ, C); },	/* 0xb1 */
	function() { RES_M_R(6, IY + EQ, D); },	/* 0xb2 */
	function() { RES_M_R(6, IY + EQ, E); },	/* 0xb3 */
	function() { RES_M_R(6, IY + EQ, H); },	/* 0xb4 */
	function() { RES_M_R(6, IY + EQ, L); },	/* 0xb5 */
	function() { RES_M(6, IY + EQ); },	/* 0xb6 */
	function() { RES_M_R(6, IY + EQ, A); },	/* 0xb7 */

	function() { RES_M_R(7, IY + EQ, B); },	/* 0xb8 */
	function() { RES_M_R(7, IY + EQ, C); },	/* 0xb9 */
	function() { RES_M_R(7, IY + EQ, D); },	/* 0xba */
	function() { RES_M_R(7, IY + EQ, E); },	/* 0xbb */
	function() { RES_M_R(7, IY + EQ, H); },	/* 0xbc */
	function() { RES_M_R(7, IY + EQ, L); },	/* 0xbd */
	function() { RES_M(7, IY + EQ); },	/* 0xbe */
	function() { RES_M_R(7, IY + EQ, A); },	/* 0xbf */

	function() { SET_M_R(0, IY + EQ, B); },	/* 0xc0 */
	function() { SET_M_R(0, IY + EQ, C); },	/* 0xc1 */
	function() { SET_M_R(0, IY + EQ, D); },	/* 0xc2 */
	function() { SET_M_R(0, IY + EQ, E); },	/* 0xc3 */
	function() { SET_M_R(0, IY + EQ, H); },	/* 0xc4 */
	function() { SET_M_R(0, IY + EQ, L); },	/* 0xc5 */
	function() { SET_M(0, IY + EQ); },	/* 0xc6 */
	function() { SET_M_R(0, IY + EQ, A); },	/* 0xc7 */

	function() { SET_M_R(1, IY + EQ, B); },	/* 0xc8 */
	function() { SET_M_R(1, IY + EQ, C); },	/* 0xc9 */
	function() { SET_M_R(1, IY + EQ, D); },	/* 0xca */
	function() { SET_M_R(1, IY + EQ, E); },	/* 0xcb */
	function() { SET_M_R(1, IY + EQ, H); },	/* 0xcc */
	function() { SET_M_R(1, IY + EQ, L); },	/* 0xcd */
	function() { SET_M(1, IY + EQ); },	/* 0xce */
	function() { SET_M_R(1, IY + EQ, A); },	/* 0xcf */

	function() { SET_M_R(2, IY + EQ, B); },	/* 0xd0 */
	function() { SET_M_R(2, IY + EQ, C); },	/* 0xd1 */
	function() { SET_M_R(2, IY + EQ, D); },	/* 0xd2 */
	function() { SET_M_R(2, IY + EQ, E); },	/* 0xd3 */
	function() { SET_M_R(2, IY + EQ, H); },	/* 0xd4 */
	function() { SET_M_R(2, IY + EQ, L); },	/* 0xd5 */
	function() { SET_M(2, IY + EQ); },	/* 0xd6 */
	function() { SET_M_R(2, IY + EQ, A); },	/* 0xd7 */

	function() { SET_M_R(3, IY + EQ, B); },	/* 0xd8 */
	function() { SET_M_R(3, IY + EQ, C); },	/* 0xd9 */
	function() { SET_M_R(3, IY + EQ, D); },	/* 0xda */
	function() { SET_M_R(3, IY + EQ, E); },	/* 0xdb */
	function() { SET_M_R(3, IY + EQ, H); },	/* 0xdc */
	function() { SET_M_R(3, IY + EQ, L); },	/* 0xdd */
	function() { SET_M(3, IY + EQ); },	/* 0xde */
	function() { SET_M_R(3, IY + EQ, A); },	/* 0xdf */

	function() { SET_M_R(4, IY + EQ, B); },	/* 0xe0 */
	function() { SET_M_R(4, IY + EQ, C); },	/* 0xe1 */
	function() { SET_M_R(4, IY + EQ, D); },	/* 0xe2 */
	function() { SET_M_R(4, IY + EQ, E); },	/* 0xe3 */
	function() { SET_M_R(4, IY + EQ, H); },	/* 0xe4 */
	function() { SET_M_R(4, IY + EQ, L); },	/* 0xe5 */
	function() { SET_M(4, IY + EQ); },	/* 0xe6 */
	function() { SET_M_R(4, IY + EQ, A); },	/* 0xe7 */

	function() { SET_M_R(5, IY + EQ, B); },	/* 0xe8 */
	function() { SET_M_R(5, IY + EQ, C); },	/* 0xe9 */
	function() { SET_M_R(5, IY + EQ, D); },	/* 0xea */
	function() { SET_M_R(5, IY + EQ, E); },	/* 0xeb */
	function() { SET_M_R(5, IY + EQ, H); },	/* 0xec */
	function() { SET_M_R(5, IY + EQ, L); },	/* 0xed */
	function() { SET_M(5, IY + EQ); },	/* 0xee */
	function() { SET_M_R(5, IY + EQ, A); },	/* 0xef */

	function() { SET_M_R(6, IY + EQ, B); },	/* 0xf0 */
	function() { SET_M_R(6, IY + EQ, C); },	/* 0xf1 */
	function() { SET_M_R(6, IY + EQ, D); },	/* 0xf2 */
	function() { SET_M_R(6, IY + EQ, E); },	/* 0xf3 */
	function() { SET_M_R(6, IY + EQ, H); },	/* 0xf4 */
	function() { SET_M_R(6, IY + EQ, L); },	/* 0xf5 */
	function() { SET_M(6, IY + EQ); },	/* 0xf6 */
	function() { SET_M_R(6, IY + EQ, A); },	/* 0xf7 */

	function() { SET_M_R(7, IY + EQ, B); },	/* 0xf8 */
	function() { SET_M_R(7, IY + EQ, C); },	/* 0xf9 */
	function() { SET_M_R(7, IY + EQ, D); },	/* 0xfa */
	function() { SET_M_R(7, IY + EQ, E); },	/* 0xfb */
	function() { SET_M_R(7, IY + EQ, H); },	/* 0xfc */
	function() { SET_M_R(7, IY + EQ, L); },	/* 0xfd */
	function() { SET_M(7, IY + EQ); },	/* 0xfe */
	function() { SET_M_R(7, IY + EQ, A); }	/* 0xff */
);

_z80executeFDXX = new Array(
	function() { NOP(); },	/* 0x00 */
	function() { NOP(); },	/* 0x01 */
	function() { NOP(); },	/* 0x02 */
	function() { NOP(); },	/* 0x03 */
	function() { NOP(); },	/* 0x04 */
	function() { NOP(); },	/* 0x05 */
	function() { NOP(); },	/* 0x06 */
	function() { NOP(); },	/* 0x07 */

	function() { NOP(); },	/* 0x08 */
	function() { ADD16(IY, BC); },	/* 0x09 */
	function() { NOP(); },	/* 0x0a */
	function() { NOP(); },	/* 0x0b */
	function() { NOP(); },	/* 0x0c */
	function() { NOP(); },	/* 0x0d */
	function() { NOP(); },	/* 0x0e */
	function() { NOP(); },	/* 0x0f */

	function() { NOP(); },	/* 0x10 */
	function() { NOP(); },	/* 0x11 */
	function() { NOP(); },	/* 0x12 */
	function() { NOP(); },	/* 0x13 */
	function() { NOP(); },	/* 0x14 */
	function() { NOP(); },	/* 0x15 */
	function() { NOP(); },	/* 0x16 */
	function() { NOP(); },	/* 0x17 */

	function() { NOP(); },	/* 0x18 */
	function() { ADD16(IY, DE); },	/* 0x19 */
	function() { NOP(); },	/* 0x1a */
	function() { NOP(); },	/* 0x1b */
	function() { NOP(); },	/* 0x1c */
	function() { NOP(); },	/* 0x1d */
	function() { NOP(); },	/* 0x1e */
	function() { NOP(); },	/* 0x1f */

	function() { NOP(); },	/* 0x20 */
	function() { LD16(IY, IMM16); },	/* 0x21 */
	function() { ST16(IMM16, IY); },	/* 0x22 */
	function() { INC16(IY); },	/* 0x23 */
	function() { INC8(IYH); },	/* 0x24 */
	function() { DEC8(IYH); },	/* 0x25 */
	function() { LD(IYH, IMM8); },	/* 0x26 */
	function() { NOP(); },	/* 0x27 */

	function() { NOP(); },	/* 0x28 */
	function() { ADD16(IY, IY); },	/* 0x29 */
	function() { LD16(IY, MEM16(IMM16)); },	/* 0x2a */
	function() { DEC16(IY); },	/* 0x2b */
	function() { INC8(IYL); },	/* 0x2c */
	function() { DEC8(IYL); },	/* 0x2d */
	function() { LD(IYL, IMM8); },	/* 0x2e */
	function() { NOP(); },	/* 0x2f */

	function() { NOP(); },	/* 0x30 */
	function() { NOP(); },	/* 0x31 */
	function() { NOP(); },	/* 0x32 */
	function() { NOP(); },	/* 0x33 */
	function() { INC8_M(IY + EQ); }, /* 0x34 */
	function() { DEC8_M(IY + EQ); }, /* 0x35 */
	function() { ST8(IY + EQ, MEM8(PC + 2)); }, /* 0x36 */
	function() { NOP(); },	/* 0x37 */

	function() { NOP(); },	/* 0x38 */
	function() { ADD16(IY, SP); }, /* 0x39 */
	function() { NOP(); },	/* 0x3a */
	function() { NOP(); },	/* 0x3b */
	function() { NOP(); },	/* 0x3c */
	function() { NOP(); },	/* 0x3d */
	function() { NOP(); },	/* 0x3e */
	function() { NOP(); },	/* 0x3f */

	function() { NOP(); },	/* 0x40 */
	function() { NOP(); },	/* 0x41 */
	function() { NOP(); },	/* 0x42 */
	function() { NOP(); },	/* 0x43 */
	function() { LD(B, IYH); },	/* 0x44 */
	function() { LD(B, IYL); },	/* 0x45 */
	function() { LD(B, MEM8(IY + EQ)); },	/* 0x46 */
	function() { NOP(); },	/* 0x47 */

	function() { NOP(); },	/* 0x48 */
	function() { NOP(); },	/* 0x49 */
	function() { NOP(); },	/* 0x4a */
	function() { NOP(); },	/* 0x4b */
	function() { LD(C, IYH); },	/* 0x4c */
	function() { LD(C, IYL); },	/* 0x4d */
	function() { LD(C, MEM8(IY + EQ)); },	/* 0x4e */
	function() { NOP(); },	/* 0x4f */

	function() { NOP(); },	/* 0x50 */
	function() { NOP(); },	/* 0x51 */
	function() { NOP(); },	/* 0x52 */
	function() { NOP(); },	/* 0x53 */
	function() { LD(D, IYH); },	/* 0x54 */
	function() { LD(D, IYL); },	/* 0x55 */
	function() { LD(D, MEM8(IY + EQ)); },	/* 0x56 */
	function() { NOP(); },	/* 0x57 */

	function() { NOP(); },	/* 0x58 */
	function() { NOP(); },	/* 0x59 */
	function() { NOP(); },	/* 0x5a */
	function() { NOP(); },	/* 0x5b */
	function() { LD(E, IYH); },	/* 0x5c */
	function() { LD(E, IYL); },	/* 0x5d */
	function() { LD(E, MEM8(IY + EQ)); },	/* 0x5e */
	function() { NOP(); },	/* 0x5f */

	function() { LD(IYH, B); },	/* 0x60 */
	function() { LD(IYH, C); },	/* 0x61 */
	function() { LD(IYH, D); },	/* 0x62 */
	function() { LD(IYH, E); },	/* 0x63 */
	function() { LD(IYH, H); },	/* 0x64 */
	function() { LD(IYH, L); },	/* 0x65 */
	function() { LD(H, MEM8(IY + EQ)); },	/* 0x66 */
	function() { LD(IYH, A); },	/* 0x67 */

	function() { LD(IYL, B); },	/* 0x68 */
	function() { LD(IYL, C); },	/* 0x69 */
	function() { LD(IYL, D); },	/* 0x6a */
	function() { LD(IYL, E); },	/* 0x6b */
	function() { LD(IYL, H); },	/* 0x6c */
	function() { LD(IYL, L); },	/* 0x6d */
	function() { LD(L, MEM8(IY + EQ)); },	/* 0x6e */
	function() { LD(IYL, A); },	/* 0x6f */

	function() { ST8(IY + EQ, B); },	/* 0x70 */
	function() { ST8(IY + EQ, C); },	/* 0x71 */
	function() { ST8(IY + EQ, D); },	/* 0x72 */
	function() { ST8(IY + EQ, E); },	/* 0x73 */
	function() { ST8(IY + EQ, H); },	/* 0x74 */
	function() { ST8(IY + EQ, L); },	/* 0x75 */
	function() { NOP(); },	/* 0x76 */
	function() { ST8(IY + EQ, A); },	/* 0x77 */

	function() { NOP(); },	/* 0x78 */
	function() { NOP(); },	/* 0x79 */
	function() { NOP(); },	/* 0x7a */
	function() { NOP(); },	/* 0x7b */
	function() { LD(A, IYH); },	/* 0x7c */
	function() { LD(A, IYL); },	/* 0x7d */
	function() { LD(A, MEM8(IY + EQ)); },	/* 0x7e */
	function() { NOP(); },	/* 0x7f */

	function() { NOP(); },	/* 0x80 */
	function() { NOP(); },	/* 0x81 */
	function() { NOP(); },	/* 0x82 */
	function() { NOP(); },	/* 0x83 */
	function() { ADD8(IYH); },	/* 0x84 */
	function() { ADD8(IYL); },	/* 0x85 */
	function() { ADD8(MEM8(IY + EQ)); },	/* 0x86 */
	function() { NOP(); },	/* 0x87 */

	function() { NOP(); },	/* 0x88 */
	function() { NOP(); },	/* 0x89 */
	function() { NOP(); },	/* 0x8a */
	function() { NOP(); },	/* 0x8b */
	function() { ADC8(IYH); },	/* 0x8c */
	function() { ADC8(IYL); },	/* 0x8d */
	function() { ADC8(MEM8(IY + EQ)); },	/* 0x8e */
	function() { NOP(); },	/* 0x8f */

	function() { NOP(); },	/* 0x90 */
	function() { NOP(); },	/* 0x91 */
	function() { NOP(); },	/* 0x92 */
	function() { NOP(); },	/* 0x93 */
	function() { SUB8(IYH); },	/* 0x94 */
	function() { SUB8(IYL); },	/* 0x95 */
	function() { SUB8(MEM8(IY + EQ)); },	/* 0x96 */
	function() { NOP(); },	/* 0x97 */

	function() { NOP(); },	/* 0x98 */
	function() { NOP(); },	/* 0x99 */
	function() { NOP(); },	/* 0x9a */
	function() { NOP(); },	/* 0x9b */
	function() { SBC8(IYH); },	/* 0x9c */
	function() { SBC8(IYL); },	/* 0x9d */
	function() { SBC8(MEM8(IY + EQ)); },	/* 0x9e */
	function() { NOP(); },	/* 0x9f */

	function() { NOP(); },	/* 0xa0 */
	function() { NOP(); },	/* 0xa1 */
	function() { NOP(); },	/* 0xa2 */
	function() { NOP(); },	/* 0xa3 */
	function() { AND(IYH); },	/* 0xa4 */
	function() { AND(IYL); },	/* 0xa5 */
	function() { AND(MEM8(IY + EQ)); },	/* 0xa6 */
	function() { NOP(); },	/* 0xa7 */

	function() { NOP(); },	/* 0xa8 */
	function() { NOP(); },	/* 0xa9 */
	function() { NOP(); },	/* 0xaa */
	function() { NOP(); },	/* 0xab */
	function() { XOR(IYH); },	/* 0xac */
	function() { XOR(IYL); },	/* 0xad */
	function() { XOR(MEM8(IY + EQ)); },	/* 0xae */
	function() { NOP(); },	/* 0xaf */

	function() { NOP(); },	/* 0xb0 */
	function() { NOP(); },	/* 0xb1 */
	function() { NOP(); },	/* 0xb2 */
	function() { NOP(); },	/* 0xb3 */
	function() { OR(IYH); },	/* 0xb4 */
	function() { OR(IYL); },	/* 0xb5 */
	function() { OR(MEM8(IY + EQ)); },	/* 0xb6 */
	function() { NOP(); },	/* 0xb7 */

	function() { NOP(); },	/* 0xb8 */
	function() { NOP(); },	/* 0xb9 */
	function() { NOP(); },	/* 0xba */
	function() { NOP(); },	/* 0xbb */
	function() { CP(IYH); },	/* 0xbc */
	function() { CP(IYL); },	/* 0xbd */
	function() { CP(MEM8(IY + EQ)); },	/* 0xbe */
	function() { NOP(); },	/* 0xbf */

	function() { NOP(); },	/* 0xc0 */
	function() { NOP(); },	/* 0xc1 */
	function() { NOP(); },	/* 0xc2 */
	function() { NOP(); },	/* 0xc3 */
	function() { NOP(); },	/* 0xc4 */
	function() { NOP(); },	/* 0xc5 */
	function() { NOP(); },	/* 0xc6 */
	function() { NOP(); },	/* 0xc7 */

	function() { NOP(); },	/* 0xc8 */
	function() { NOP(); },	/* 0xc9 */
	function() { NOP(); },	/* 0xca */
	function() { var op = MEM8(PC + 2); _state = _stateDDCBXX[op]; _length = _lengthDDCBXX[op]; _z80executeFDCBXX[op](); },	/* 0xcb */
	function() { NOP(); },	/* 0xcc */
	function() { NOP(); },	/* 0xcd */
	function() { NOP(); },	/* 0xce */
	function() { NOP(); },	/* 0xcf */

	function() { NOP(); },	/* 0xd0 */
	function() { NOP(); },	/* 0xd1 */
	function() { NOP(); },	/* 0xd2 */
	function() { NOP(); },	/* 0xd3 */
	function() { NOP(); },	/* 0xd4 */
	function() { NOP(); },	/* 0xd5 */
	function() { NOP(); },	/* 0xd6 */
	function() { NOP(); },	/* 0xd7 */

	function() { NOP(); },	/* 0xd8 */
	function() { NOP(); },	/* 0xd9 */
	function() { NOP(); },	/* 0xda */
	function() { NOP(); },	/* 0xdb */
	function() { NOP(); },	/* 0xdc */
	function() { NOP(); },	/* 0xdd */
	function() { NOP(); },	/* 0xde */
	function() { NOP(); },	/* 0xdf */

	function() { NOP(); },	/* 0xe0 */
	function() { POP(IY); },	/* 0xe1 */
	function() { NOP(); },	/* 0xe2 */
	function() { EX_M(SP, IY); },	/* 0xe3 */
	function() { NOP(); },	/* 0xe4 */
	function() { PUSH(IY); },	/* 0xe5 */
	function() { NOP(); },	/* 0xe6 */
	function() { NOP(); },	/* 0xe7 */

	function() { NOP(); },	/* 0xe8 */
	function() { JP(true, IY); },	/* 0xe9 */
	function() { NOP(); },	/* 0xea */
	function() { NOP(); },	/* 0xeb */
	function() { NOP(); },	/* 0xec */
	function() { NOP(); },	/* 0xed */
	function() { NOP(); },	/* 0xee */
	function() { NOP(); },	/* 0xef */

	function() { NOP(); },	/* 0xf0 */
	function() { NOP(); },	/* 0xf1 */
	function() { NOP(); },	/* 0xf2 */
	function() { NOP(); },	/* 0xf3 */
	function() { NOP(); },	/* 0xf4 */
	function() { NOP(); },	/* 0xf5 */
	function() { NOP(); },	/* 0xf6 */
	function() { NOP(); },	/* 0xf7 */

	function() { NOP(); },	/* 0xf8 */
	function() { LD16(SP, IY); },	/* 0xf9 */
	function() { NOP(); },	/* 0xfa */
	function() { NOP(); },	/* 0xfb */
	function() { NOP(); },	/* 0xfc */
	function() { NOP(); },	/* 0xfd */
	function() { NOP(); },	/* 0xfe */
	function() { NOP(); }	/* 0xff */
);

_z80executeXX = new Array(
	function() { NOP(); },	/* 0x00 */
	function() { LD16(BC, IMM16); },	/* 0x01 */
	function() { ST8(BC, A); },	/* 0x02 */
	function() { INC16(BC); },	/* 0x03 */
	function() { INC8(B); },	/* 0x04 */
	function() { DEC8(B); },	/* 0x05 */
	function() { LD(B, IMM8); },	/* 0x06 */
	function() { RLCA(); },	/* 0x07 */

	function() { EX_R(AF, AF_D); },	/* 0x08 */
	function() { ADD16(HL, BC); },	/* 0x09 */
	function() { LD(A, MEM8(BC)); },	/* 0x0a */
	function() { DEC16(BC); },	/* 0x0b */
	function() { INC8(C); },	/* 0x0c */
	function() { DEC8(C); },	/* 0x0d */
	function() { LD(C, IMM8); },	/* 0x0e */
	function() { RRCA(); },	/* 0x0f */

	function() { DJNZ(EQ); },	/* 0x10 */
	function() { LD16(DE, IMM16); },	/* 0x11 */
	function() { ST8(DE, A); },	/* 0x12 */
	function() { INC16(DE); },	/* 0x13 */
	function() { INC8(D); },	/* 0x14 */
	function() { DEC8(D); },	/* 0x15 */
	function() { LD(D, IMM8); },	/* 0x16 */
	function() { RLA(); },	/* 0x17 */

	function() { JR(true, EQ); },	/* 0x18 */
	function() { ADD16(HL, DE); },	/* 0x19 */
	function() { LD(A, MEM8(DE)); },	/* 0x1a */
	function() { DEC16(DE); },	/* 0x1b */
	function() { INC8(E); },	/* 0x1c */
	function() { DEC8(E); },	/* 0x1d */
	function() { LD(E, IMM8); },	/* 0x1e */
	function() { RRA(); },	/* 0x1f */

	function() { JR(CC_NZ, EQ); },	/* 0x20 */
	function() { LD16(HL, IMM16); },	/* 0x21 */
	function() { ST16(IMM16, HL); },	/* 0x22 */
	function() { INC16(HL); },	/* 0x23 */
	function() { INC8(H); },	/* 0x24 */
	function() { DEC8(H); },	/* 0x25 */
	function() { LD(H, IMM8); },	/* 0x26 */
	function() { DAA(); },	/* 0x27 */

	function() { JR(CC_Z, EQ); },	/* 0x28 */
	function() { ADD16(HL, HL); },	/* 0x29 */
	function() { LD16(HL, MEM16(IMM16)); },	/* 0x2a */
	function() { DEC16(HL); },	/* 0x2b */
	function() { INC8(L); },	/* 0x2c */
	function() { DEC8(L); },	/* 0x2d */
	function() { LD(L, IMM8); },	/* 0x2e */
	function() { CPL(); },	/* 0x2f */

	function() { JR(CC_NC, EQ); },	/* 0x30 */
	function() { LD16(SP, IMM16); },	/* 0x31 */
	function() { ST8(IMM16, A); },	/* 0x32 */
	function() { INC16(SP); },	/* 0x33 */
	function() { INC8_M(HL); },	/* 0x34 */
	function() { DEC8_M(HL); },	/* 0x35 */
	function() { ST8(HL, IMM8); },	/* 0x36 */
	function() { SCF(); },	/* 0x37 */

	function() { JR(CC_C, EQ); },	/* 0x38 */
	function() { ADD16(HL, SP); },	/* 0x39 */
	function() { LD(A, MEM8(IMM16)); },	/* 0x3a */
	function() { DEC16(SP); },	/* 0x3b */
	function() { INC8(A); },	/* 0x3c */
	function() { DEC8(A); },	/* 0x3d */
	function() { LD(A, IMM8); },	/* 0x3e */
	function() { CCF(); },	/* 0x3f */

	function() { LD(B, B); },	/* 0x40 */
	function() { LD(B, C); },	/* 0x41 */
	function() { LD(B, D); },	/* 0x42 */
	function() { LD(B, E); },	/* 0x43 */
	function() { LD(B, H); },	/* 0x44 */
	function() { LD(B, L); },	/* 0x45 */
	function() { LD(B, MEM8(HL)); },	/* 0x46 */
	function() { LD(B, A); },	/* 0x47 */

	function() { LD(C, B); },	/* 0x48 */
	function() { LD(C, C); },	/* 0x49 */
	function() { LD(C, D); },	/* 0x4a */
	function() { LD(C, E); },	/* 0x4b */
	function() { LD(C, H); },	/* 0x4c */
	function() { LD(C, L); },	/* 0x4d */
	function() { LD(C, MEM8(HL)); },	/* 0x4e */
	function() { LD(C, A); },	/* 0x4f */

	function() { LD(D, B); },	/* 0x50 */
	function() { LD(D, C); },	/* 0x51 */
	function() { LD(D, D); },	/* 0x52 */
	function() { LD(D, E); },	/* 0x53 */
	function() { LD(D, H); },	/* 0x54 */
	function() { LD(D, L); },	/* 0x55 */
	function() { LD(D, MEM8(HL)); },	/* 0x56 */
	function() { LD(D, A); },	/* 0x57 */

	function() { LD(E, B); },	/* 0x58 */
	function() { LD(E, C); },	/* 0x59 */
	function() { LD(E, D); },	/* 0x5a */
	function() { LD(E, E); },	/* 0x5b */
	function() { LD(E, H); },	/* 0x5c */
	function() { LD(E, L); },	/* 0x5d */
	function() { LD(E, MEM8(HL)); },	/* 0x5e */
	function() { LD(E, A); },	/* 0x5f */

	function() { LD(H, B); },	/* 0x60 */
	function() { LD(H, C); },	/* 0x61 */
	function() { LD(H, D); },	/* 0x62 */
	function() { LD(H, E); },	/* 0x63 */
	function() { LD(H, H); },	/* 0x64 */
	function() { LD(H, L); },	/* 0x65 */
	function() { LD(H, MEM8(HL)); },	/* 0x66 */
	function() { LD(H, A); },	/* 0x67 */

	function() { LD(L, B); },	/* 0x68 */
	function() { LD(L, C); },	/* 0x69 */
	function() { LD(L, D); },	/* 0x6a */
	function() { LD(L, E); },	/* 0x6b */
	function() { LD(L, H); },	/* 0x6c */
	function() { LD(L, L); },	/* 0x6d */
	function() { LD(L, MEM8(HL)); },	/* 0x6e */
	function() { LD(L, A); },	/* 0x6f */

	function() { ST8(HL, B); },	/* 0x70 */
	function() { ST8(HL, C); },	/* 0x71 */
	function() { ST8(HL, D); },	/* 0x72 */
	function() { ST8(HL, E); },	/* 0x73 */
	function() { ST8(HL, H); },	/* 0x74 */
	function() { ST8(HL, L); },	/* 0x75 */
	function() { HALT(); },	/* 0x76 */
	function() { ST8(HL, A); },	/* 0x77 */

	function() { LD(A, B); },	/* 0x78 */
	function() { LD(A, C); },	/* 0x79 */
	function() { LD(A, D); },	/* 0x7a */
	function() { LD(A, E); },	/* 0x7b */
	function() { LD(A, H); },	/* 0x7c */
	function() { LD(A, L); },	/* 0x7d */
	function() { LD(A, MEM8(HL)); },	/* 0x7e */
	function() { LD(A, A); },	/* 0x7f */

	function() { ADD8(B); },	/* 0x80 */
	function() { ADD8(C); },	/* 0x81 */
	function() { ADD8(D); },	/* 0x82 */
	function() { ADD8(E); },	/* 0x83 */
	function() { ADD8(H); },	/* 0x84 */
	function() { ADD8(L); },	/* 0x85 */
	function() { ADD8(MEM8(HL)); },	/* 0x86 */
	function() { ADD8(A); },	/* 0x87 */

	function() { ADC8(B); },	/* 0x88 */
	function() { ADC8(C); },	/* 0x89 */
	function() { ADC8(D); },	/* 0x8a */
	function() { ADC8(E); },	/* 0x8b */
	function() { ADC8(H); },	/* 0x8c */
	function() { ADC8(L); },	/* 0x8d */
	function() { ADC8(MEM8(HL)); },	/* 0x8e */
	function() { ADC8(A); },	/* 0x8f */

	function() { SUB8(B); },	/* 0x90 */
	function() { SUB8(C); },	/* 0x91 */
	function() { SUB8(D); },	/* 0x92 */
	function() { SUB8(E); },	/* 0x93 */
	function() { SUB8(H); },	/* 0x94 */
	function() { SUB8(L); },	/* 0x95 */
	function() { SUB8(MEM8(HL)); },	/* 0x96 */
	function() { SUB8(A); },	/* 0x97 */

	function() { SBC8(B); },	/* 0x98 */
	function() { SBC8(C); },	/* 0x99 */
	function() { SBC8(D); },	/* 0x9a */
	function() { SBC8(E); },	/* 0x9b */
	function() { SBC8(H); },	/* 0x9c */
	function() { SBC8(L); },	/* 0x9d */
	function() { SBC8(MEM8(HL)); },	/* 0x9e */
	function() { SBC8(A); },	/* 0x9f */

	function() { AND(B); },	/* 0xa0 */
	function() { AND(C); },	/* 0xa1 */
	function() { AND(D); },	/* 0xa2 */
	function() { AND(E); },	/* 0xa3 */
	function() { AND(H); },	/* 0xa4 */
	function() { AND(L); },	/* 0xa5 */
	function() { AND(MEM8(HL)); },	/* 0xa6 */
	function() { AND(A); },	/* 0xa7 */

	function() { XOR(B); },	/* 0xa8 */
	function() { XOR(C); },	/* 0xa9 */
	function() { XOR(D); },	/* 0xaa */
	function() { XOR(E); },	/* 0xab */
	function() { XOR(H); },	/* 0xac */
	function() { XOR(L); },	/* 0xad */
	function() { XOR(MEM8(HL)); },	/* 0xae */
	function() { XOR(A); },	/* 0xaf */

	function() { OR(B); },	/* 0xb0 */
	function() { OR(C); },	/* 0xb1 */
	function() { OR(D); },	/* 0xb2 */
	function() { OR(E); },	/* 0xb3 */
	function() { OR(H); },	/* 0xb4 */
	function() { OR(L); },	/* 0xb5 */
	function() { OR(MEM8(HL)); },	/* 0xb6 */
	function() { OR(A); },	/* 0xb7 */

	function() { CP(B); },	/* 0xb8 */
	function() { CP(C); },	/* 0xb9 */
	function() { CP(D); },	/* 0xba */
	function() { CP(E); },	/* 0xbb */
	function() { CP(H); },	/* 0xbc */
	function() { CP(L); },	/* 0xbd */
	function() { CP(MEM8(HL)); },	/* 0xbe */
	function() { CP(A); },	/* 0xbf */

	function() { RET(CC_NZ); },	/* 0xc0 */
	function() { POP(BC); },	/* 0xc1 */
	function() { JP(CC_NZ, IMM16); },	/* 0xc2 */
	function() { JP(true, IMM16); },	/* 0xc3 */
	function() { CALL(CC_NZ, IMM16); },	/* 0xc4 */
	function() { PUSH(BC); },	/* 0xc5 */
	function() { ADD8(IMM8); },	/* 0xc6 */
	function() { RST(0x00); },	/* 0xc7 */

	function() { RET(CC_Z); },	/* 0xc8 */
	function() { RET(true); },	/* 0xc9 */
	function() { JP(CC_Z, IMM16); },	/* 0xca */
	function() { var op = MEM8(++PC); _state = _stateCBXX[op]; _length = _lengthCBXX[op]; _z80executeCBXX[op](); },	/* 0xcb */
	function() { CALL(CC_Z, IMM16); },	/* 0xcc */
	function() { CALL(true, IMM16); },	/* 0xcd */
	function() { ADC8(IMM8); },	/* 0xce */
	function() { RST(0x08); },	/* 0xcf */

	function() { RET(CC_NC); },	/* 0xd0 */
	function() { POP(DE); },	/* 0xd1 */
	function() { JP(CC_NC, IMM16); },	/* 0xd2 */
	function() { OUT(IMM8, A); },	/* 0xd3 */
	function() { CALL(CC_NC, IMM16); },	/* 0xd4 */
	function() { PUSH(DE); },	/* 0xd5 */
	function() { SUB8(IMM8); },	/* 0xd6 */
	function() { RST(0x10); },	/* 0xd7 */

	function() { RET(CC_C); },	/* 0xd8 */
	function() { EXX(); },	/* 0xd9 */
	function() { JP(CC_C, IMM16); },	/* 0xda */
	function() { IN_N(A, IMM8); },	/* 0xdb */
	function() { CALL(CC_C, IMM16); },	/* 0xdc */
	function() { var op = MEM8(++PC); _state = _stateDDXX[op]; _length = _lengthDDXX[op]; _z80executeDDXX[op](); },	/* 0xdd */
	function() { SBC8(IMM8); },	/* 0xde */
	function() { RST(0x18); },	/* 0xdf */

	function() { RET(CC_PO); },	/* 0xe0 */
	function() { POP(HL); },	/* 0xe1 */
	function() { JP(CC_PO, IMM16); },	/* 0xe2 */
	function() { EX_M(SP, HL); },	/* 0xe3 */
	function() { CALL(CC_PO, IMM16); },	/* 0xe4 */
	function() { PUSH(HL); },	/* 0xe5 */
	function() { AND(IMM8); },	/* 0xe6 */
	function() { RST(0x20); },	/* 0xe7 */

	function() { RET(CC_PE); },	/* 0xe8 */
	function() { JP(true, HL); },	/* 0xe9 */
	function() { JP(CC_PE, IMM16); },	/* 0xea */
	function() { EX_R(DE, HL); },	/* 0xeb */
	function() { CALL(CC_PE, IMM16); },	/* 0xec */
	function() { var op = MEM8(++PC); _state = _stateEDXX[op]; _length = _lengthEDXX[op]; _z80executeEDXX[op](); },	/* 0xed */
	function() { XOR(IMM8); },	/* 0xee */
	function() { RST(0x28); },	/* 0xef */

	function() { RET(CC_P); },	/* 0xf0 */
	function() { POP(AF); },	/* 0xf1 */
	function() { JP(CC_P, IMM16); },	/* 0xf2 */
	function() { DI(); },	/* 0xf3 */
	function() { CALL(CC_P, IMM16); },	/* 0xf4 */
	function() { PUSH(AF); },	/* 0xf5 */
	function() { OR(IMM8); },	/* 0xf6 */
	function() { RST(0x30); },	/* 0xf7 */

	function() { RET(CC_M); },	/* 0xf8 */
	function() { LD16(SP, HL); },	/* 0xf9 */
	function() { JP(CC_M, IMM16); },	/* 0xfa */
	function() { EI(); },	/* 0xfb */
	function() { CALL(CC_M, IMM16); },	/* 0xfc */
	function() { var op = MEM8(++PC); _state = _stateDDXX[op]; _length = _lengthDDXX[op]; _z80executeFDXX[op](); },	/* 0xfd */
	function() { CP(IMM8); },	/* 0xfe */
	function() { RST(0x38); }	/* 0xff */
);

function z80int1() {
	if(!(INT_MODE == 1 && IFF == 3))
		return false;

	HLT = false;
	IFF = 0;
	z80restStates -= 13;
	INTERRUPT(0x38);
	return true;
}

function z80reset() {
	INT_MODE = 0;
	IFF = 0;
	HLT = false;
	A = F = B = C = D = E = H = L = IXH = IXL = IYH = IYL = A_D = F_D = B_D = C_D = D_D = D_E = H_D = L_D = I = 0xff;
	SP = 0xffff;
	PC = 0;
	restStates = 0;
	return true;
}

function z80execute(s) {
	z80executeStates = s;
	z80restStates = Math.floor(z80restStates + s);

	if(HLT) {
		z80restStates = 0;
		return;
	}

	do {
		var op = MEM8(PC);
		_state = _stateXX[op];
		_length = _lengthXX[op];
		_z80executeXX[op]();

		z80restStates -= _state;
	} while(z80restStates > 0);
}

function z80debug() {
	alert(
	"AF=" + A.toString(16) + " " + F.toString(16) + " (AF'=" + A_D.toString(16) + " " + F_D.toString(16) + ")\n" +
	"BC=" + B.toString(16) + " " + C.toString(16) + " (BC'=" + B_D.toString(16) + " " + C_D.toString(16) + ")\n" +
	"DE=" + D.toString(16) + " " + E.toString(16) + " (DE'=" + D_D.toString(16) + " " + E_D.toString(16) + ")\n" +
	"HL=" + H.toString(16) + " " + L.toString(16) + " (HL'=" + H_D.toString(16) + " " + L_D.toString(16) + ")\n" +
	"IX=" + IX.toString(16) + "\n" +
	"IY=" + IY.toString(16) + "\n" +
	"SP=" + SP.toString(16) + "\n" +
	"PC=" + PC.toString(16) + "\n"
	);
}

/* eof */
